'' FreeBASIC binding for iup-3.15
''
'' based on the C header files:
''   Copyright (C) 1994-2015 Tecgraf, PUC-Rio.
''
''   Permission is hereby granted, free of charge, to any person obtaining
''   a copy of this software and associated documentation files (the
''   "Software"), to deal in the Software without restriction, including
''   without limitation the rights to use, copy, modify, merge, publish,
''   distribute, sublicense, and/or sell copies of the Software, and to
''   permit persons to whom the Software is furnished to do so, subject to
''   the following conditions:
''
''   The above copyright notice and this permission notice shall be
''   included in all copies or substantial portions of the Software.
''
''   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
''   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
''   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
''   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
''   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
''   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
''   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
''
'' translated to FreeBASIC by:
''   Copyright © 2015 FreeBASIC development team

#pragma Once

#inclib "iup"

#ifdef __fb_win32__
	#inclib "gdi32"
	#inclib "user32"
	#inclib "comdlg32"
	#inclib "comctl32"
	#inclib "ole32"
	#inclib "advapi32"
	#inclib "shell32"
	#inclib "uuid"
#else
	#ifdef __USE_GTK3__
		#inclib "gtk-3"
		#inclib "gdk-3"
		#inclib "cairo"
		#inclib "pangocairo-1.0"
		#inclib "gdk_pixbuf-2.0"
		#inclib "pango-1.0"
		#inclib "gobject-2.0"
		#inclib "gmodule-2.0"
		#inclib "glib-2.0"
	#else
		#inclib "gtk-x11-2.0"
		#inclib "gdk-x11-2.0"
		#inclib "pangox-1.0"
		#inclib "gdk_pixbuf-2.0"
		#inclib "pango-1.0"
		#inclib "gobject-2.0"
		#inclib "gmodule-2.0"
		#inclib "glib-2.0"
	#endif

#endif

#include Once "iupkey.bi"
#include Once "iupdef.bi"

Extern "C"
	
	#define __IUP_H
	#define IUP_NAME "IUP - Portable User Interface"
	#define IUP_COPYRIGHT "Copyright (C) 1994-2015 Tecgraf, PUC-Rio."
	#define IUP_DESCRIPTION "Multi-platform toolkit for building graphical user interfaces."
	#define IUP_VERSION "3.15"
	Const IUP_VERSION_NUMBER = 315000
	#define IUP_VERSION_DATE "2015/07/06"
	Type Ihandle As Ihandle_
	Type Icallback As Function(Byval As Ihandle Ptr) As Long
	
	Declare Function IupOpen(Byval argc As Long Ptr, Byval argv As Zstring Ptr Ptr Ptr) As Long
	Declare Sub IupClose()
	Declare Sub IupImageLibOpen()
	Declare Function IupMainLoop() As Long
	Declare Function IupLoopStep() As Long
	Declare Function IupLoopStepWait() As Long
	Declare Function IupMainLoopLevel() As Long
	Declare Sub IupFlush()
	Declare Sub IupExitLoop()
	Declare Function IupRecordInput(Byval filename As Const Zstring Ptr, Byval mode As Long) As Long
	Declare Function IupPlayInput(Byval filename As Const Zstring Ptr) As Long
	Declare Sub IupUpdate(Byval ih As Ihandle Ptr)
	Declare Sub IupUpdateChildren(Byval ih As Ihandle Ptr)
	Declare Sub IupRedraw(Byval ih As Ihandle Ptr, Byval children As Long)
	Declare Sub IupRefresh(Byval ih As Ihandle Ptr)
	Declare Sub IupRefreshChildren(Byval ih As Ihandle Ptr)
	Declare Function IupHelp(Byval url As Const Zstring Ptr) As Long
	Declare Function IupLoad(Byval filename As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupLoadBuffer(Byval buffer As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupVersion() As Zstring Ptr
	Declare Function IupVersionDate() As Zstring Ptr
	Declare Function IupVersionNumber() As Long
	Declare Sub IupSetLanguage(Byval lng As Const Zstring Ptr)
	Declare Function IupGetLanguage() As Zstring Ptr
	Declare Sub IupSetLanguageString(Byval Name As Const Zstring Ptr, Byval Str As Const Zstring Ptr)
	Declare Sub IupStoreLanguageString(Byval Name As Const Zstring Ptr, Byval Str As Const Zstring Ptr)
	Declare Function IupGetLanguageString(Byval Name As Const Zstring Ptr) As Zstring Ptr
	Declare Sub IupSetLanguagePack(Byval ih As Ihandle Ptr)
	Declare Sub IupDestroy(Byval ih As Ihandle Ptr)
	Declare Sub IupDetach(Byval child As Ihandle Ptr)
	Declare Function IupAppend(Byval ih As Ihandle Ptr, Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupInsert(Byval ih As Ihandle Ptr, Byval ref_child As Ihandle Ptr, Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetChild(Byval ih As Ihandle Ptr, Byval Pos As Long) As Ihandle Ptr
	Declare Function IupGetChildPos(Byval ih As Ihandle Ptr, Byval child As Ihandle Ptr) As Long
	Declare Function IupGetChildCount(Byval ih As Ihandle Ptr) As Long
	Declare Function IupGetNextChild(Byval ih As Ihandle Ptr, Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetBrother(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetParent(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetDialog(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetDialogChild(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupReparent(Byval ih As Ihandle Ptr, Byval new_parent As Ihandle Ptr, Byval ref_child As Ihandle Ptr) As Long
	Declare Function IupPopup(Byval ih As Ihandle Ptr, Byval x As Long, Byval y As Long) As Long
	Declare Function IupShow(Byval ih As Ihandle Ptr) As Long
	Declare Function IupShowXY(Byval ih As Ihandle Ptr, Byval x As Long, Byval y As Long) As Long
	Declare Function IupHide(Byval ih As Ihandle Ptr) As Long
	Declare Function IupMap(Byval ih As Ihandle Ptr) As Long
	Declare Sub IupUnmap(Byval ih As Ihandle Ptr)
	Declare Sub IupResetAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr)
	Declare Function IupGetAllAttributes(Byval ih As Ihandle Ptr, Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Function IupSetAtt(Byval handle_name As Const Zstring Ptr, Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, ...) As Ihandle Ptr
	Declare Function IupSetAttributes(Byval ih As Ihandle Ptr, Byval Str As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupGetAttributes(Byval ih As Ihandle Ptr) As Zstring Ptr
	Declare Sub IupSetAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrf(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval Format As Const Zstring Ptr, ...)
	Declare Sub IupSetInt(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Long)
	Declare Sub IupSetFloat(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Single)
	Declare Sub IupSetDouble(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Double)
	Declare Sub IupSetRGB(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval r As Ubyte, Byval g As Ubyte, Byval b As Ubyte)
	Declare Function IupGetAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupGetInt(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Long
	Declare Function IupGetInt2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Long
	Declare Function IupGetIntInt(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval i1 As Long Ptr, Byval i2 As Long Ptr) As Long
	Declare Function IupGetFloat(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Single
	Declare Function IupGetDouble(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Double
	Declare Sub IupGetRGB(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval r As Ubyte Ptr, Byval g As Ubyte Ptr, Byval b As Ubyte Ptr)
	Declare Sub IupSetAttributeId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrAttributeId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrfId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval Format As Const Zstring Ptr, ...)
	Declare Sub IupSetIntId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Long)
	Declare Sub IupSetFloatId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Single)
	Declare Sub IupSetDoubleId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Double)
	Declare Sub IupSetRGBId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval r As Ubyte, Byval g As Ubyte, Byval b As Ubyte)
	Declare Function IupGetAttributeId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Zstring Ptr
	Declare Function IupGetIntId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Long
	Declare Function IupGetFloatId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Single
	Declare Function IupGetDoubleId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Double
	Declare Sub IupGetRGBId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval r As Ubyte Ptr, Byval g As Ubyte Ptr, Byval b As Ubyte Ptr)
	Declare Sub IupSetAttributeId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrAttributeId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrfId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval Format As Const Zstring Ptr, ...)
	Declare Sub IupSetIntId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Long)
	Declare Sub IupSetFloatId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Single)
	Declare Sub IupSetDoubleId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Double)
	Declare Sub IupSetRGBId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval r As Ubyte, Byval g As Ubyte, Byval b As Ubyte)
	Declare Function IupGetAttributeId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long) As Zstring Ptr
	Declare Function IupGetIntId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long) As Long
	Declare Function IupGetFloatId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long) As Single
	Declare Function IupGetDoubleId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long) As Double
	Declare Sub IupGetRGBId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval r As Ubyte Ptr, Byval g As Ubyte Ptr, Byval b As Ubyte Ptr)
	Declare Sub IupSetGlobal(Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Sub IupSetStrGlobal(Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Function IupGetGlobal(Byval Name As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupSetFocus(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetFocus() As Ihandle Ptr
	Declare Function IupPreviousField(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupNextField(Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetCallback(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Icallback
	Declare Function IupSetCallback(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval func As Icallback) As Icallback
	Declare Function IupSetCallbacks(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval func As Icallback, ...) As Ihandle Ptr
	Declare Function IupGetFunction(Byval Name As Const Zstring Ptr) As Icallback
	Declare Function IupSetFunction(Byval Name As Const Zstring Ptr, Byval func As Icallback) As Icallback
	Declare Function IupGetHandle(Byval Name As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupSetHandle(Byval Name As Const Zstring Ptr, Byval ih As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGetAllNames(Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Function IupGetAllDialogs(Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Function IupGetName(Byval ih As Ihandle Ptr) As Zstring Ptr
	Declare Sub IupSetAttributeHandle(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval ih_named As Ihandle Ptr)
	Declare Function IupGetAttributeHandle(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupGetClassName(Byval ih As Ihandle Ptr) As Zstring Ptr
	Declare Function IupGetClassType(Byval ih As Ihandle Ptr) As Zstring Ptr
	Declare Function IupGetAllClasses(Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Function IupGetClassAttributes(Byval classname As Const Zstring Ptr, Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Function IupGetClassCallbacks(Byval classname As Const Zstring Ptr, Byval names As Zstring Ptr Ptr, Byval n As Long) As Long
	Declare Sub IupSaveClassAttributes(Byval ih As Ihandle Ptr)
	Declare Sub IupCopyClassAttributes(Byval src_ih As Ihandle Ptr, Byval dst_ih As Ihandle Ptr)
	Declare Sub IupSetClassDefaultAttribute(Byval classname As Const Zstring Ptr, Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Function IupClassMatch(Byval ih As Ihandle Ptr, Byval classname As Const Zstring Ptr) As Long
	Declare Function IupCreate(Byval classname As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupCreatev(Byval classname As Const Zstring Ptr, Byval params As Any Ptr Ptr) As Ihandle Ptr
	Declare Function IupCreatep(Byval classname As Const Zstring Ptr, Byval first As Any Ptr, ...) As Ihandle Ptr
	Declare Function IupFill() As Ihandle Ptr
	Declare Function IupRadio(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupVbox(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupVboxv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupZbox(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupZboxv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupHbox(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupHboxv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupNormalizer(Byval ih_first As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupNormalizerv(Byval ih_list As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupCbox(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupCboxv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupSbox(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupSplit(Byval child1 As Ihandle Ptr, Byval child2 As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupScrollBox(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupGridBox(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupGridBoxv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupExpander(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupDetachBox(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupBackgroundBox(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupFrame(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupImage(Byval Width As Long, Byval height As Long, Byval pixmap As Const Ubyte Ptr) As Ihandle Ptr
	Declare Function IupImageRGB(Byval Width As Long, Byval height As Long, Byval pixmap As Const Ubyte Ptr) As Ihandle Ptr
	Declare Function IupImageRGBA(Byval Width As Long, Byval height As Long, Byval pixmap As Const Ubyte Ptr) As Ihandle Ptr
	Declare Function IupItem(Byval title As Const Zstring Ptr, Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupSubmenu(Byval title As Const Zstring Ptr, Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupSeparator() As Ihandle Ptr
	Declare Function IupMenu(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupMenuv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupButton(Byval title As Const Zstring Ptr, Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupCanvas(Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupDialog(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupUser() As Ihandle Ptr
	Declare Function IupLabel(Byval title As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupList(Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupText(Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupMultiLine(Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupToggle(Byval title As Const Zstring Ptr, Byval action As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupTimer() As Ihandle Ptr
	Declare Function IupClipboard() As Ihandle Ptr
	Declare Function IupProgressBar() As Ihandle Ptr
	Declare Function IupVal(Byval Type As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupTabs(Byval child As Ihandle Ptr, ...) As Ihandle Ptr
	Declare Function IupTabsv(Byval children As Ihandle Ptr Ptr) As Ihandle Ptr
	Declare Function IupTree() As Ihandle Ptr
	Declare Function IupLink(Byval url As Const Zstring Ptr, Byval title As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupFlatButton(Byval title As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupSpin() As Ihandle Ptr
	Declare Function IupSpinbox(Byval child As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupSaveImageAsText(Byval ih As Ihandle Ptr, Byval file_name As Const Zstring Ptr, Byval Format As Const Zstring Ptr, Byval Name As Const Zstring Ptr) As Long
	Declare Sub IupTextConvertLinColToPos(Byval ih As Ihandle Ptr, Byval lin As Long, Byval col As Long, Byval Pos As Long Ptr)
	Declare Sub IupTextConvertPosToLinCol(Byval ih As Ihandle Ptr, Byval Pos As Long, Byval lin As Long Ptr, Byval col As Long Ptr)
	Declare Function IupConvertXYToPos(Byval ih As Ihandle Ptr, Byval x As Long, Byval y As Long) As Long
	Declare Sub IupStoreGlobal(Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Sub IupStoreAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval value As Const Zstring Ptr)
	Declare Sub IupSetfAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval Format As Const Zstring Ptr, ...)
	Declare Sub IupStoreAttributeId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetfAttributeId(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval f As Const Zstring Ptr, ...)
	Declare Sub IupStoreAttributeId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupSetfAttributeId2(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval lin As Long, Byval col As Long, Byval Format As Const Zstring Ptr, ...)
	Declare Function IupTreeSetUserId(Byval ih As Ihandle Ptr, Byval id As Long, Byval userid As Any Ptr) As Long
	Declare Function IupTreeGetUserId(Byval ih As Ihandle Ptr, Byval id As Long) As Any Ptr
	Declare Function IupTreeGetId(Byval ih As Ihandle Ptr, Byval userid As Any Ptr) As Long
	Declare Sub IupTreeSetAttributeHandle(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval ih_named As Ihandle Ptr)
	Declare Sub IupTreeSetAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Const Zstring Ptr)
	Declare Sub IupTreeStoreAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval value As Const Zstring Ptr)
	Declare Function IupTreeGetAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Zstring Ptr
	Declare Function IupTreeGetInt(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Long
	Declare Function IupTreeGetFloat(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long) As Single
	Declare Sub IupTreeSetfAttribute(Byval ih As Ihandle Ptr, Byval Name As Const Zstring Ptr, Byval id As Long, Byval Format As Const Zstring Ptr, ...)
	Declare Function IupGetActionName() As Const Zstring Ptr
	Declare Function IupMapFont(Byval iupfont As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupUnMapFont(Byval driverfont As Const Zstring Ptr) As Zstring Ptr
	Declare Function IupFileDlg() As Ihandle Ptr
	Declare Function IupMessageDlg() As Ihandle Ptr
	Declare Function IupColorDlg() As Ihandle Ptr
	Declare Function IupFontDlg() As Ihandle Ptr
	Declare Function IupProgressDlg() As Ihandle Ptr
	Declare Function IupGetFile(Byval arq As Zstring Ptr) As Long
	Declare Sub IupMessage(Byval title As Const Zstring Ptr, Byval msg As Const Zstring Ptr)
	Declare Sub IupMessagef(Byval title As Const Zstring Ptr, Byval Format As Const Zstring Ptr, ...)
	Declare Function IupAlarm(Byval title As Const Zstring Ptr, Byval msg As Const Zstring Ptr, Byval b1 As Const Zstring Ptr, Byval b2 As Const Zstring Ptr, Byval b3 As Const Zstring Ptr) As Long
	Declare Function IupScanf(Byval Format As Const Zstring Ptr, ...) As Long
	Declare Function IupListDialog(Byval Type As Long, Byval title As Const Zstring Ptr, Byval size As Long, Byval list As Const Zstring Ptr Ptr, Byval op As Long, Byval max_col As Long, Byval max_lin As Long, Byval marks As Long Ptr) As Long
	Declare Function IupGetText(Byval title As Const Zstring Ptr, Byval text As Zstring Ptr) As Long
	Declare Function IupGetColor(Byval x As Long, Byval y As Long, Byval r As Ubyte Ptr, Byval g As Ubyte Ptr, Byval b As Ubyte Ptr) As Long
	Type Iparamcb As Function(Byval dialog As Ihandle Ptr, Byval param_index As Long, Byval user_data As Any Ptr) As Long
	Declare Function IupGetParam(Byval title As Const Zstring Ptr, Byval action As Iparamcb, Byval user_data As Any Ptr, Byval Format As Const Zstring Ptr, ...) As Long
	Declare Function IupGetParamv(Byval title As Const Zstring Ptr, Byval action As Iparamcb, Byval user_data As Any Ptr, Byval Format As Const Zstring Ptr, Byval param_count As Long, Byval param_extra As Long, Byval param_data As Any Ptr Ptr) As Long
	Declare Function IupParamf(Byval Format As Const Zstring Ptr) As Ihandle Ptr
	Declare Function IupParamBox(Byval parent As Ihandle Ptr, Byval params As Ihandle Ptr Ptr, Byval count As Long) As Ihandle Ptr
	Declare Function IupLayoutDialog(Byval dialog As Ihandle Ptr) As Ihandle Ptr
	Declare Function IupElementPropertiesDialog(Byval elem As Ihandle Ptr) As Ihandle Ptr
	
	Const IUP_ERROR = 1
	Const IUP_NOERROR = 0
	Const IUP_OPENED = -1
	Const IUP_INVALID = -1
	Const IUP_INVALID_ID = -10
	Const IUP_IGNORE = -1
	Const IUP_DEFAULT = -2
	Const IUP_CLOSE = -3
	Const IUP_CONTINUE = -4
	Const IUP_CENTER = &hFFFF
	Const IUP_LEFT = &hFFFE
	Const IUP_RIGHT = &hFFFD
	Const IUP_MOUSEPOS = &hFFFC
	Const IUP_CURRENT = &hFFFB
	Const IUP_CENTERPARENT = &hFFFA
	Const IUP_TOP = IUP_LEFT
	Const IUP_BOTTOM = IUP_RIGHT
	
	Enum
		IUP_SHOW
		IUP_RESTORE
		IUP_MINIMIZE
		IUP_MAXIMIZE
		IUP_HIDE
	End Enum
	
	Enum
		IUP_SBUP
		IUP_SBDN
		IUP_SBPGUP
		IUP_SBPGDN
		IUP_SBPOSV
		IUP_SBDRAGV
		IUP_SBLEFT
		IUP_SBRIGHT
		IUP_SBPGLEFT
		IUP_SBPGRIGHT
		IUP_SBPOSH
		IUP_SBDRAGH
	End Enum
	
	#define IUP_BUTTON1 Asc("1")
	#define IUP_BUTTON2 Asc("2")
	#define IUP_BUTTON3 Asc("3")
	#define IUP_BUTTON4 Asc("4")
	#define IUP_BUTTON5 Asc("5")
	#define iup_isshift(_s) (_s[0] = Asc("S"))
	#define iup_iscontrol(_s) (_s[1] = Asc("C"))
	#define iup_isbutton1(_s) (_s[2] = Asc("1"))
	#define iup_isbutton2(_s) (_s[3] = Asc("2"))
	#define iup_isbutton3(_s) (_s[4] = Asc("3"))
	#define iup_isdouble(_s) (_s[5] = Asc("D"))
	#define iup_isalt(_s) (_s[6] = Asc("A"))
	#define iup_issys(_s) (_s[7] = Asc("Y"))
	#define iup_isbutton4(_s) (_s[8] = Asc("4"))
	#define iup_isbutton5(_s) (_s[9] = Asc("5"))
	#define isshift iup_isshift
	#define iscontrol iup_iscontrol
	#define isbutton1 iup_isbutton1
	#define isbutton2 iup_isbutton2
	#define isbutton3 iup_isbutton3
	#define isdouble iup_isdouble
	#define isalt iup_isalt
	#define issys iup_issys
	#define isbutton4 iup_isbutton4
	#define isbutton5 iup_isbutton5
	#define IUP_MASK_FLOAT "[+/-]?(/d+/.?/d*|/./d+)"
	#define IUP_MASK_UFLOAT "(/d+/.?/d*|/./d+)"
	#define IUP_MASK_EFLOAT "[+/-]?(/d+/.?/d*|/./d+)([eE][+/-]?/d+)?"
	#define IUP_MASK_FLOATCOMMA "[+/-]?(/d+/,?/d*|/,/d+)"
	#define IUP_MASK_UFLOATCOMMA "(/d+/,?/d*|/,/d+)"
	#define IUP_MASK_INT "[+/-]?/d+"
	#define IUP_MASK_UINT "/d+"
	#define IUPMASK_FLOAT IUP_MASK_FLOAT
	#define IUPMASK_UFLOAT IUP_MASK_UFLOAT
	#define IUPMASK_EFLOAT IUP_MASK_EFLOAT
	#define IUPMASK_INT IUP_MASK_INT
	#define IUPMASK_UINT IUP_MASK_UINT
	Const IUP_GETPARAM_BUTTON1 = -1
	Const IUP_GETPARAM_INIT = -2
	Const IUP_GETPARAM_BUTTON2 = -3
	Const IUP_GETPARAM_BUTTON3 = -4
	Const IUP_GETPARAM_CLOSE = -5
	Const IUP_GETPARAM_OK = IUP_GETPARAM_BUTTON1
	Const IUP_GETPARAM_CANCEL = IUP_GETPARAM_BUTTON2
	Const IUP_GETPARAM_HELP = IUP_GETPARAM_BUTTON3
	
	Enum
		IUP_RECBINARY
		IUP_RECTEXT
	End Enum
	
End Extern
