Dim Shared As String szHHK

Function chm_getStrTag_proc (sStr As String , Byref iPos As Long ) As String
	
	Dim As String sRet
	
	Dim As Long iFind = Instr(iPos , sStr , ">") 
	
	If iFind Then
		
		sRet = Mid(sStr , iPos , iFind - iPos+1)
		
		iPos = iFind+1
		
	Else
		
		sRet = Mid(sStr , iPos)
		
		iPos = 0
		
	Endif
	
	Return sRet
	
End Function

Function chm_clearspace_proc(Byref sText As String) As String Export
	
	Dim As String sRet = String(Len(sText) , 0)
	
	Dim As Long j
	
	For i As Long = 0 To Len(sText)
		
		If sText[i] <> 32 Then
			
			sRet[j] = sText[i]
			
			j+=1
			
		Endif
		
	Next
	
	Return sRet
	
End Function

Function chm_xmlgetid_proc(sStr As String) As Long
	
	Dim As String sTemp = Lcase(chm_clearspace_proc(sStr))
	
	If Instr(sTemp , "<ul>") Then
		
		Return 1
		
	Elseif Instr(sTemp, "<li>") Then
		
		Return 2
		
	Elseif Instr(sTemp, "name=" & Chr(34) & "name" & Chr(34)) Then
		
		Return 3
		
	Elseif Instr(sTemp, "name=" & Chr(34) & "local" & Chr(34)) Then
		
		Return 4
		
	Elseif Instr(sTemp, "</ul>") Then
		
		Return 5
		
	Endif
	
End Function

Function chm_xmlgetvalue_proc(sStr As String) As String
	
	Dim As String sTemp
	
	Dim As Long iFindStart = Instr(sStr , "value=" & Chr(34))
	
	Dim As Long iFindEnd = Instr(sStr , Chr(34) & ">")
	
	If iFindStart Andalso iFindEnd Then
		
		sTemp = Mid(sStr , iFindStart+7 , iFindEnd - (iFindStart+7))
		
		Return sTemp
		
	Endif
	
End Function

Function chm_xmlreplace_mnemonic_proc(sStr As String) As String
	
	Dim As String sPat
	
	Dim As Long iStart , iFindStart , iFindEnd , iEnc
	
	While 1
		
		iFindStart = Instr(iFindStart+1 , sStr , "&")
		
		If iFindStart Then
			
			iFindEnd = Instr(iFindStart+1 , sStr , ";")
			
			If iFindEnd Then
				
				sPat = Lcase(Mid(sStr , iFindStart , iFindEnd-iFindStart+1))
				
				For i As Long = 0 To Ubound(arr_mnem)
					
					If arr_mnem(i).sMnem = sPat Then
						
						sStr = Mid(sStr , 1 , iFindStart-1) & Chr(32) & Mid(sStr , iFindEnd+1)
						
						If arr_mnem(i).uni = 273 Then
							
							sStr[iFindStart-1] = 240
							
						Else
							
							sStr[iFindStart-1] = arr_mnem(i).uni
							
						Endif
						
						iEnc = 1
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit While
				
			Endif
			
		Else
			
			Exit While
			
		Endif
		
	Wend
	
	Return sStr
	
End Function

Function chm_list_proc Cdecl( h As chmFile Ptr , pUI As  chmUnitInfo Ptr, context As Any Ptr ) As Integer
	
	If CHM_RESOLVE_SUCCESS = chm_resolve_object(h,  pUI->path, pUI) Then
		
		If Lcase(Right(pUI->path , 4)) = ".hhk" Then
			
			Dim As Zstring Ptr pszBuffer = Callocate(pUI->length+1)
			
			if pszBuffer then
			
				Dim As Longint iLen = chm_retrieve_object(h, pUI, pszBuffer, 0, pUI->length)
				
				szHHK = Lcase(*pszBuffer)
				
				Deallocate(pszBuffer)
			
			else
			
				winout_error_memory_proc()
			
			endif
			
		Endif
		
	Endif
	
	Return CHM_ENUMERATOR_CONTINUE
	
End Function

Function chm_compare_help_keywords_proc(sKeyWord As String) As Long
	
	For i As Long = 1 To 100
		
		If pArrayTHelpList(i).pFirst Andalso _
		(pArrayTHelpList(i).pFirst)->psz Then
			
			Dim As NODETHELPLIST Ptr pTemp = (pArrayTHelpList(i).pFirst)->pNext
			
			While pTemp
				
				If pTemp->psz Andalso *(pTemp->psz) = sKeyWord Then
					
					Return i
					
				Endif				
				
				pTemp = pTemp->pNext
				
			Wend
			
		Endif
		
	Next
	
End Function

Sub chm_enum_keywords_proc(szFile As String , iIndex As Long)
	
	Dim As chmFile Ptr pFile = chm_open(szFile)
	
	If pFile Then
		
		szHHK = ""
		
		chm_enumerate( pFile, CHM_ENUMERATE_NORMAL, Cast(Any Ptr,@chm_list_proc), 0 )
		
		chm_close( pFile )
		
		If Len(szHHK) Then
			
			Dim As Integer iULFirst
			
			Dim As Long iPos = 1
			
			While iPos
				
				Dim As String s = chm_getStrTag_proc(szHHK , iPos)
				
				If Len(s) Then
					
					Select Case chm_xmlgetid_proc(s)
							
						Case 1
							
							iULFirst = 1
							
						Case 3
							
							If iULFirst Then
								
								Dim As String sValue = chm_xmlgetvalue_proc(s)
								
								sValue = chm_xmlreplace_mnemonic_proc(sValue)
								
								pArrayTHelpList(iIndex).addLast(Lcase(sValue))
								
							Endif
							
					End Select
					
				Endif
				
			Wend
			
		Endif
		
	Endif
	
End Sub