
Function fl_is_file_proc(pszFile As Zstring Ptr) As Long
	
	#ifdef __fb_win32__
		
		Dim As WIN32_FIND_DATA g_FileInformation
		
		Dim As Handle hFind = FindFirstFile(pszFile, @g_FileInformation)
		
		If hFind <> Cast(Any Ptr, -1) Then
			
			If g_FileInformation.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY  Then				
			Else
				
				Function = 1
				
			Endif
			
			FindClose(hFind)
			
		Endif
		
	#else
		
		Dim As _stat Ptr tempBuf
		
		tempBuf = Callocate (Sizeof(_stat)+100)
		
		if tempBuf then
			
			stat( pszFile , tempBuf)
			
			If S_ISDIR( tempBuf->st_mode ) = 0 Then
				
				Function = 1
				
			Endif
			
			Deallocate(tempBuf)
			
		else
			
			winout_error_memory_proc()
			
		endif
		
	#endif
	
End Function

Function fl_read_file_proc(pszNameFile As Zstring Ptr, Byref iSize As Long) As Byte Ptr Export
	
	If Len(*pszNameFile) = 0 orelse FileExists(pszNameFile) = 0 Then Return 0
	
	Dim id As Long
	
	Dim As Byte Ptr pbData
	
	id = Freefile
	
	Open *pszNameFile For Binary As #id
	
	If Err = 0 Then
		
		iSize = Lof(id)
		
		pbData = Allocate(iSize+1)
		
		if pbData then
			
			Get #id , 1 , *pbData , iSize
			
			pbData[iSize] = 0
			
			Close #id
			
		else
			
			winout_error_memory_proc()
			
		endif
		
		Return pbData
		
	Endif
	
End Function

Function fl_write_file_proc(pszNameFile As Zstring Ptr, pbData As Byte Ptr,  iSize As Long) As Long Export
	
	If Len(*pszNameFile) = 0 Then Return 0
	
	If Fileexists(*pszNameFile) = -1 Then
		
		If Kill(*pszNameFile) <> 0 Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"errorrewite"))
			
			return 0
			
		Endif
		
	Endif
	
	Dim id As Long
	
	id = Freefile
	
	Open *pszNameFile For Binary As #id
	
	If Err = 0 Then
		
		Put #id , 1 , *pbData , iSize
		
		Close #id
		
		Return 1
		
	Endif
	
End Function

Function fl_prepare_before_saving_proc( Byref iSizeReturn As Long , idTabs As Long  , iProjectFlag As Long = 0) As Byte Ptr Export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return 0
	
	Dim As Zstring Ptr pszData  = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "VALUE")
	
	if pszData = 0 then return 0
	
	Dim iFlagDeallocate As Long = 0
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Editor","savecase")  = "YES" Then
		
		Dim iFlagYesCase As Long = 1
		
		Select Case Lcase(Right(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME") , 4))
				
			Case ".xml" , ".asm" , ".txt" , ".cpp"
				
				iFlagYesCase = 0
				
		End Select
		
		If Lcase(Right(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME") , 2)) = ".c" Andalso _
		Lcase(Right(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME") , 3)) = ".rc" Then
			
			iFlagYesCase = 0
			
		Endif
		
		If iFlagYesCase Then
			
			pszData = cnv_convert_case_before_save_file(pszData  , iFlagDeallocate)
			
		Endif
		
	Endif
	
	Dim As Zstring Ptr pszCurrentEnc = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING")
	
	Dim As Long iSize = Len(*pszData)
	
	Dim As Long iUnicode
	
	If iSize > 3 Then
		
		iUnicode = Cast(Long Ptr,pszData)[0]
		
	Endif
	
	Select Case *pszCurrentEnc
			
			#ifdef __fb_win32__
				
				Case "UTF-8" , "UTF-8 BOM"
				
			#else
				
				Case "UTF-8" , "UTF-8 BOM" , "Default System" , ""
				
			#endif
			
			
			If *pszCurrentEnc = "UTF-8 BOM" Then
				
				If iUnicode <> 0 Andalso (iUnicode And &hFFFFFF) = &hBFBBEF Then
					
					Dim As Zstring Ptr pszTemp = Callocate (iSize+1)
					
					if pszTemp then
						
						*pszTemp = *pszData
						
						iSizeReturn = Len(*pszTemp)
						
						Function =  Cast(Byte Ptr,pszTemp)
						
					else
						
						winout_error_memory_proc()
						
					endif
					
				Else
					
					Dim As Zstring Ptr pszTemp = Callocate (iSize+4)
					
					if pszTemp then
						
						*pszTemp = Chr(&hEF,&hBB,&hBF)
						
						*pszTemp = *pszTemp & *pszData
						
						iSizeReturn = Len(*pszTemp)
						
						Function =  Cast(Byte Ptr,pszTemp)
						
					else
						
						winout_error_memory_proc()
						
					endif
					
				Endif
				
			Else
				
				If iUnicode <> 0 Andalso (iUnicode And &hFFFFFF) = &hBFBBEF Then
					
					Dim As Zstring Ptr pszTemp = Callocate (iSize+1)
					
					if pszTemp then
						
						*pszTemp = Mid(*pszData,4,Len(*pszData)-3)
						
						iSizeReturn = Len(*pszTemp)
						
						Function =  Cast(Byte Ptr,pszTemp)
						
					else
						
						winout_error_memory_proc()
						
					endif
					
				Else
					
					Dim As Zstring Ptr pszTemp = Callocate (iSize+4)
					
					if pszTemp then
						
						*pszTemp = *pszData
						
						iSizeReturn = Len(*pszTemp)
						
						Function =  Cast(Byte Ptr,pszTemp)
						
					else
						
						winout_error_memory_proc()
						
					endif
					
				Endif
				
			Endif
			
		Case Else	
			
			Dim As Byte Ptr pszToCode		
			
			Dim iSizeRetIconv As Integer		
			
			If iUnicode <> 0 Andalso (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
				Dim As Zstring Ptr pszReturnData = Callocate (iSize+1)
				
				if pszReturnData then
					
					*pszReturnData = Mid(*pszData,4,Len(*pszData)-3)
					
					iSize = Len(*pszReturnData)
					
					pszToCode = enc_encode_buffer_proc(pszCurrentEnc , "UTF-8" , pszReturnData , iSize ,iSizeRetIconv , ,iProjectFlag)
					
					Deallocate (pszReturnData)
					
				else
					
					winout_error_memory_proc()
					
					If iFlagDeallocate Then Deallocate (pszData)
					
					return 0
					
				endif
				
			Else
				
				pszToCode = enc_encode_buffer_proc(pszCurrentEnc , "UTF-8" , pszData , iSize ,iSizeRetIconv , ,iProjectFlag) 
				
			Endif	
			
			If iSizeRetIconv > 3 Then
				
				iUnicode = Cast(Long Ptr,pszToCode)[0]
				
			Else
				
				iUnicode = 0
				
			Endif							
			
			iSizeReturn = iSizeRetIconv	
			
			Select Case *pszCurrentEnc
					
					Case	"UTF-32LE" , "UCS-4LE"
					
					If iUnicode <> 0 Andalso iUnicode = &hFEFF Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						if pbReturnData then
							
							*Cast(Long Ptr,pbReturnData) = &hFEFF
							
							memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)
							
							iSizeReturn+=4
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						if pszToCode then Deallocate ( pszToCode )
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pbReturnData
						
					Endif
					
				Case "UTF-32BE","UCS-4BE"
					
					If iUnicode <> 0 Andalso iUnicode = &hFFFE0000 Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						if pbReturnData then
							
							*Cast(Long Ptr,pbReturnData) = &hFFFE0000
							
							memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)	
							
							iSizeReturn+=4
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						if pszToCode then Deallocate ( pszToCode )
						
						Return pbReturnData	
						
					Endif
					
				Case  "UTF-32","UCS-4","UCS-4-INTERNAL"
					
					If iUnicode <> 0 Andalso (iUnicode = &hFFFE0000 Orelse iUnicode = &hFEFF)  Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+5)
						
						if pbReturnData then
							
							*Cast(Long Ptr,pbReturnData) = &hFEFF
							
							memcpy((pbReturnData+4), pszToCode , iSizeRetIconv)	
							
							iSizeReturn+=4
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						if pszToCode then Deallocate ( pszToCode )
						
						Return pbReturnData	
						
					Endif
					
				Case "UTF-16LE" , "UCS-2LE"
					
					If iUnicode <> 0 Andalso ((iUnicode And &hFFFF) = &hFEFF)  Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						if pbReturnData then
							
							*Cast(Short Ptr,pbReturnData) = &hFEFF
							
							memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
							
							iSizeReturn+=2
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						if pszToCode then Deallocate ( pszToCode )
						
						Return pbReturnData			
						
					Endif
					
				Case "UTF-16BE" , "UCS-2BE"
					
					If iUnicode <> 0 Andalso ((iUnicode And &hFFFF) = &hFFFE)  Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						if pbReturnData then
							
							*Cast(Short Ptr,pbReturnData) = &hFFFE
							
							memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
							
							iSizeReturn+=2
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						if pszToCode then Deallocate ( pszToCode )
						
						Return pbReturnData			
						
					Endif
					
				Case "UTF-16" , "UCS-2" , "UCS-2-INTERNAL"
					
					If iUnicode <> 0 Andalso (((iUnicode And &hFFFF) = &hFFFE) Orelse ((iUnicode And &hFFFF) = &hFEFF)) Then
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						Return pszToCode
						
					Else
						
						Dim pbReturnData As Byte Ptr = Callocate(iSizeRetIconv+3)
						
						if pbReturnData then
							
							*Cast(Short Ptr,pbReturnData) = &hFEFF
							
							memcpy((pbReturnData+2), pszToCode , iSizeRetIconv)
							
							iSizeReturn+=2
							
						else
							
							winout_error_memory_proc()
							
						endif
						
						If iFlagDeallocate Then Deallocate (pszData)
						
						if pszToCode then Deallocate ( pszToCode )
						
						Return pbReturnData			
						
					Endif
					
				Case Else
					
					If iFlagDeallocate Then Deallocate (pszData)
					
					Return pszToCode
					
			End Select
			
	End Select
	
End Function

Function fl_save_as_proc(idTabs As Long ) As Long Export
	
	Dim As Long iSizeReturn
	
	Dim As Zstring Ptr pszPath
	
	Static As String szPath
	
	Dim As Byte Ptr pbData = fl_prepare_before_saving_proc(iSizeReturn , idTabs )
	
	If pbData <> 0 Then
		
		pszPath = fdlg_save_dialog_proc()
		
		If *pszPath<>"" Then
			
			If fl_write_file_proc(pszPath,pbData,iSizeReturn) = 0 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorwritefile"))
				
			Else
				
				#ifdef __fb_win32__
					
					Dim As Long iPosSpl = Instrrev (*pszPath,"\")
					
				#else
					
					Dim As Long iPosSpl = Instrrev (*pszPath,"/")
					
				#endif
				
				Dim As Zstring*1000 sztPath, sztName , szToCode
				
				sztPath = Mid(*pszPath,1,iPosSpl)
				
				sztName = Mid(*pszPath,iPosSpl+1,Len(*pszPath)-iPosSpl)				
				
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH", sztPath)
				
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME", sztName)
				
				IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")
				
				Dim As Zstring*1000 szTempBufPath = sztPath & sztName
				
				Dim As Zstring*2 szEncZero = ""
				
				Dim As Integer iSizeRet
				
				Dim As Zstring Ptr pszEncPath = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8",Strptr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
				
				IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
				
				If pszEncPath Then Deallocate (pszEncPath)
				
				#ifdef __fb_win32__
					
					iSizeRet = 0
					
					Dim As Zstring Ptr pszCodedNameTab = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8",Strptr(szEncZero), Cast(Byte Ptr,@sztName), Len(sztName) , iSizeRet))
					
					If pszCodedNameTab Then
						
						IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB", pszCodedNameTab)
						
						Deallocate (pszCodedNameTab)
						
					Endif
					
				#else
					
					IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB", sztName )
					
				#endif				
				
				IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", idTabs ,IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAMETAB"))
				
				szPath = "IUP_FB_Editor - " & sztPath & sztName
				
				szPath = enc_encode_path_proc(szPath , 1)
				
				IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
				
				IupRefresh(TGlobalVariables->dlg)
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
				
				Function = 1			
				
			Endif		
			
		Endif
		
		Deallocate(pbData)
		
	Endif		
	
End Function

Function fl_save_proc(idTabs As Long , iProjectFlag As Long = 0 ) As Long Export
	
	Dim As Zstring Ptr pszName = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME")
	
	Dim As Zstring Ptr pszPath = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH")
	
	Static As String szPath
	
	If Len(*pszName) = 0 Then
		
		fl_save_as_proc(idTabs)
		
	Else
		
		Dim As Long iSizeReturn
		
		Dim As Byte Ptr pbData = fl_prepare_before_saving_proc(iSizeReturn , idTabs  , iProjectFlag)
		
		If pbData <> 0 Then
			
			Dim As Zstring*1000 sztPath = *pszPath & *pszName
			
			If fl_write_file_proc(sztPath ,pbData,iSizeReturn) = 0 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"),_
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorwritefile"))
				
				Deallocate(pbData)
				
			Else
				
				IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idtabs).multitext)
				
				szPath = "IUP_FB_Editor - " & *pszPath & *pszName
				
				szPath = enc_encode_path_proc(szPath , 1)
				
				IupSetAttribute(TGlobalVariables->dlg, "TITLE", szPath)
				
				Deallocate(pbData)
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "CHANGLBL"),"FGCOLOR" , TGlobalVariables->szColorThemeCore)
				
				#ifdef __fb_win32__
					IupSetAttribute(TGlobalVariables->tabs,"FORECOLOR" , TGlobalVariables->szColorThemeCore)
					IupSetAttribute(TGlobalVariables->tabs,"TABFORECOLOR" & idTabs , TGlobalVariables->szColorThemeCore)
				#else
					#ifdef __fb_64bit__
						IupSetAttribute(TGlobalVariables->tabs,"FORECOLOR" , TGlobalVariables->szColorThemeCore)
						IupSetAttribute(TGlobalVariables->tabs,"TABFORECOLOR" & idTabs , TGlobalVariables->szColorThemeCore)
					#endif
				#endif
				
				Return 1
				
			Endif
			
		Endif
		
	Endif
	
End Function

Sub fl_save_all_proc() Export 
	
	Dim As Long  ic = IupGetChildCount(TGlobalVariables->tabs)
	
	If ic < 2 Then Exit Sub
	
	For i As Long = 1 To ic-1
		
		If *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext, "ISCHANGES") = "YES" Then
			
			fl_save_proc(i)
			
		Endif
		
	Next
	
End Sub

Function fl_prepare_path(sPath As String) As String
	
	Dim As String*1000 sPath2
	
	For i As Long = 0 To Len(sPath)-1
		
		If (sPath)[i] = &h25 Then
			
			Var szSimvol = "&h" & Chr((sPath)[i+1], (sPath)[i+2])
			
			Var iSimvol = Val(szSimvol)
			
			sPath2 &= Chr(iSimvol)
			
			i+=2
		Else
			
			sPath2 &= Chr((sPath)[i])
			
		Endif
		
	Next
	
	Return sPath2
	
End Function

Sub fl_open_file_proc (pszPath As Zstring Ptr) Export
	
	If pszPath = 0 Then Exit Sub
	
	Dim As String sInputFile = *pszPath
	
	#ifdef __fb_win32__
	#else
		
		sInputFile = fl_prepare_path(sInputFile)
		
	#endif	
	
	If Right(sInputFile,1) = "|" Then
		
		Dim As Long iPosSpl = Instr (sInputFile,"|")
		
		Dim As Integer  ic = IupGetChildCount(TGlobalVariables->tabs)
		
		Dim As Zstring*1000 sztPath , sztName
		
		#ifdef __fb_win32__
			
			sztPath = Mid(sInputFile,1,iPosSpl-1) & "\"
			
		#else
			
			sztPath = Mid(sInputFile,1,iPosSpl-1) & "/"
			
		#endif
		
		While 1
			
			If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttab"))
				
				Exit While
				
			Endif
			
			Dim As Long iPosEndSpl = Instr (iPosSpl+1,sInputFile,"|")
			
			sztName = Mid(sInputFile,iPosSpl+1,iPosEndSpl-(iPosSpl+1))
			
			#ifdef __fb_win32__
				
				Dim As Integer iSizeTempRet
				
				Dim As Zstring*2 szZero = ""
				
				Dim As Zstring Ptr pszToCode
				
				pszToCode = Cast(Zstring Ptr ,enc_encode_buffer_proc("UTF-8" , szZero , Cast(Byte Ptr,@sztName) , Len(sztName) , iSizeTempRet))
				
			#endif
			
			iPosSpl = iPosEndSpl
			
			Dim iSizeFile As Long
			
			Dim As Byte Ptr pbData = fl_read_file_proc(sztPath & sztName , iSizeFile)
			
			If pbData <> 0 Then
				
				Dim As Long iUnicode = Cast(Long Ptr,pbData)[0]
				
				Dim As Zstring*21 szEnc
				
				If iUnicode = &hFEFF Then
					
					szEnc = "UTF-32LE"
					
				Elseif iUnicode = &hFFFE0000 Then
					
					szEnc = "UTF-32BE"
					
				Elseif (iUnicode And &hFFFF) = &hFEFF Then
					
					szEnc = "UTF-16LE"
					
				Elseif (iUnicode And &hFFFF) = &hFFFE Then
					
					szEnc = "UTF-16BE"
					
				Elseif (iUnicode And &hFFFFFF) = &hBFBBEF Then
					
					szEnc = "UTF-8 BOM"
					
				Else
					
					szEnc = TGlobalVariables->szDefaultSystemEncoding
					
				Endif
				
				Dim As Ihandle Ptr mt = IupScintilla()
				
				IupSetStrAttribute(mt, "CURRENTENCODING", szEnc)
				
				IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(mt, "CURRENTENCODING"))
				
				IupAppend(TGlobalVariables->tabs, IupBackgroundBox(IupVbox(mt, NULL)))
				
				IupMap(IupGetParent(IupGetParent(mt)))
				
				mtxt_set_attribute_multitext_proc(mt)
				
				Dim As Integer iSizeReturn
				
				Dim As Byte Ptr pbFileToCode
				
				If szEnc = "UTF-8 BOM" Then
					
					pbFileToCode = enc_encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , mt)
					
				Else
					
					pbFileToCode = enc_encode_buffer_proc("UTF-8" , szEnc , pbData , iSizeFile , iSizeReturn , mt)
					
				Endif
				
				IupSetStrAttribute(mt, "FILEPATH", sztPath)
				
				IupSetStrAttribute(mt, "FILENAME", sztName)
				
				Dim As Zstring*1000 szTempBufPath = sztPath & sztName
				
				Dim As Zstring*2 szEncZero = ""
				
				Dim As Integer iSizeRet
				
				Dim As Zstring Ptr pszEncPath = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8",Strptr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
				
				IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
				
				If pszEncPath Then Deallocate (pszEncPath)
				
				#ifdef __fb_win32__
					
					If pszToCode Then
						
						IupSetStrAttribute(mt, "FILENAMETAB", pszToCode)
						
						Deallocate (pszToCode)
						
					Endif					
					
				#else
					
					IupSetStrAttribute(mt, "FILENAMETAB", sztName)
					
				#endif
				
				Scope
					
					Dim As String sName = *IupGetAttribute(mt, "FILENAMETAB")
					
					mtxt_set_attribute_for_another_files(mt , sName)
					
				End Scope
				
				IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,IupGetAttribute(mt, "FILENAMETAB"))
				
				IupRefresh(TGlobalVariables->dlg)
				
				IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
				
				If pbFileToCode Then
					
					iUnicode = Cast(Long Ptr,pbFileToCode)[0]
					
					If (iUnicode And &hFFFFFF) = &hBFBBEF Then
						
						IupSetStrAttribute(mt, "VALUE", pbFileToCode+3)
						
					Else
						
						IupSetStrAttribute(mt, "VALUE", pbFileToCode)
						
					Endif
					
				Endif
				
				If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
					
					IupScintillaSendMessage( mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
					
				Else
					
					IupScintillaSendMessage( mt , SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
					
				Endif
				
				TGlobalVariables->tTabsOptions(ic).multitext = mt
				
				IupSetAttribute(mt, "ISCHANGES", "NO")
				
				IupScintillaSendMessage(mt, SCI_EMPTYUNDOBUFFER, 0,  0)
				
				if TGlobalVariables->bFlagFolding = 1 then
					
					IupScintillaSendMessage( mt, 4003, 0, cast(any ptr , -1) ) ' SCI_COLOURISE
					
				EndIf
				
				If pbFileToCode Then Deallocate (pbFileToCode)
				
				If pbData Then Deallocate (pbData)
				
				ic+=1
				
			Endif	
			
			If iPosEndSpl = Len(sInputFile) Then Exit While
			
		Wend	
		
	Else
		
		Static boolFlagOutputErrorMessage As Boolean
		
		If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
			
			If boolFlagOutputErrorMessage = False Then
				
				IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttab"))
				
				boolFlagOutputErrorMessage = True				
				
			Endif
			
			Exit Sub
			
		Else
			
			boolFlagOutputErrorMessage = False
			
		Endif
		
		#ifdef __fb_win32__
			
			Dim As Long iPosSpl = Instrrev (sInputFile,"\")
			
		#else
			
			Dim As Long iPosSpl = Instrrev (sInputFile,"/")
			
		#endif
		
		If fl_is_file_proc(Strptr(sInputFile)) = 0 Then
			
			Exit Sub
			
		Endif		
		
		Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
		
		Dim iSizeFile As Long
		
		Dim As Byte Ptr pbData = fl_read_file_proc(Strptr(sInputFile),iSizeFile)
		
		If pbData <> 0 Then
			
			Dim As Long iUnicode = Cast(Long Ptr,pbData)[0]
			
			Dim As Zstring*21 szEnc
			
			If iUnicode = &hFEFF Then
				
				szEnc = "UTF-32LE"
				
			Elseif iUnicode = &hFFFE0000 Then
				
				szEnc = "UTF-32BE"
				
			Elseif (iUnicode And &hFFFF) = &hFEFF Then
				
				szEnc = "UTF-16LE"
				
			Elseif (iUnicode And &hFFFF) = &hFFFE Then
				
				szEnc = "UTF-16BE"
				
			Elseif (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
				szEnc = "UTF-8 BOM"
				
			Else
				
				szEnc = TGlobalVariables->szDefaultSystemEncoding
				
			Endif
			
			Dim As Ihandle Ptr mt = IupScintilla()
			
			IupSetStrAttribute(mt, "CURRENTENCODING", szEnc)
			
			IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(mt, "CURRENTENCODING"))
			
			IupAppend(TGlobalVariables->tabs,IupBackgroundBox(IupVbox(mt, NULL)))
			
			IupMap(IupGetParent(IupGetParent(mt)))
			
			mtxt_set_attribute_multitext_proc(mt)
			
			Dim As Zstring*1000 sztPath, sztName
			
			If iPosSpl = 0 Then
				
				sztPath = ""
				
			Else
				
				sztPath = Mid(sInputFile,1,iPosSpl)
				
			Endif
			
			sztName = Mid(sInputFile,iPosSpl+1,Len(sInputFile)-iPosSpl)
			
			#ifdef __fb_win32__				
				
				Dim As Integer iSizeTempRet
				
				Dim As Zstring*2 szZero = ""
				
				Dim As Zstring Ptr pszToCode
				
				pszToCode = Cast(Zstring Ptr ,enc_encode_buffer_proc("UTF-8" , szZero , Cast(Byte Ptr,@sztName) , Len(sztName) , iSizeTempRet))		
				
				If pszToCode Then
					
					IupSetStrAttribute(mt, "FILENAMETAB", pszToCode)
					
					Deallocate (pszToCode)
					
				Endif					
				
			#else
				
				IupSetStrAttribute(mt, "FILENAMETAB", sztName )
				
			#endif
			
			Scope
				
				Dim As String sName = *IupGetAttribute(mt, "FILENAMETAB")
				
				mtxt_set_attribute_for_another_files(mt , sName)
				
			End Scope
			
			Dim As Integer iSizeReturn
			
			Dim As Byte Ptr pbFileToCode
			
			If szEnc = "UTF-8 BOM" Then
				
				pbFileToCode = enc_encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , mt)
				
			Else
				
				pbFileToCode = enc_encode_buffer_proc("UTF-8" , szEnc , pbData , iSizeFile , iSizeReturn , mt)		
				
			Endif
			
			IupSetStrAttribute(mt, "FILEPATH", sztPath)
			
			IupSetStrAttribute(mt, "FILENAME", sztName)
			
			Dim As Zstring*1000 szTempBufPath = sztPath & sztName
			
			Dim As Zstring*2 szEncZero = ""
			
			Dim As Integer iSizeRet
			
			Dim As Zstring Ptr pszEncPath = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8",Strptr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
			
			IupConfigRecentUpdate(TGlobalVariables->hConfig, pszEncPath )
			
			If pszEncPath Then Deallocate (pszEncPath)
			
			TGlobalVariables->tTabsOptions(ic).multitext = mt
			
			IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,IupGetAttribute(mt, "FILENAMETAB"))
			
			Dim As Zstring*20 szRaster = *IupGetAttribute(TGlobalVariables->buildbox, "RASTERSIZE")
			
			IupRefresh(TGlobalVariables->dlg)
			
			IupSetAttribute(TGlobalVariables->buildbox, "RASTERSIZE" , Strptr(szRaster))
			
			IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
			
			If pbFileToCode Then
				
				iUnicode = Cast(Long Ptr,pbFileToCode)[0]
				
				If (iUnicode And &hFFFFFF) = &hBFBBEF Then
					
					IupSetStrAttribute(mt, "VALUE", pbFileToCode+3)
					
				Else
					
					IupSetStrAttribute(mt, "VALUE", pbFileToCode)
					
				Endif
				
			Endif
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
				IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
			Else
				
				IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
			Endif			
			
			IupSetAttribute(mt, "ISCHANGES", "NO")
			
			IupScintillaSendMessage(mt, SCI_EMPTYUNDOBUFFER, 0,  0)
			
			If pbFileToCode Then Deallocate (pbFileToCode)
			
			If pbData Then Deallocate (pbData)
			
			IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
			
			if TGlobalVariables->bFlagFolding = 1 then
				
				IupScintillaSendMessage( mt, 4003, 0, cast(any ptr , -1) ) ' SCI_COLOURISE
				
			EndIf
			
		Endif
		
	Endif
	
	If pProject.iProjectLoad Then
		
		tb_fill_combobuild_proc()
		
	Endif	
	
	tmr_update_after_changes()
	
End Sub

Sub fl_open_file_project_proc(pszPath As Zstring Ptr , iTypeFile As Long , iIndexArray As Long)
	
	If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttab"))
		
		Exit Sub
		
	Endif
	
	#ifdef __fb_win32__
		
		Dim As Long iPosSpl = Instrrev (*pszPath,"\")
		
	#else
		
		Dim As Long iPosSpl = Instrrev (*pszPath,"/")
		
	#endif		
	
	Dim As Integer ic = IupGetChildCount(TGlobalVariables->tabs)
	
	Dim iSizeFile As Long
	
	Dim As Byte Ptr pbData = fl_read_file_proc(pszPath,iSizeFile)
	
	If pbData <> 0 Then
		
		Dim As Long iUnicode = Cast(Long Ptr,pbData)[0]
		
		Dim As Zstring*21 szEnc = *(pProject.pszEncProject)
		
		Dim As Ihandle Ptr mt = IupScintilla()
		
		IupSetStrAttribute(mt, "CURRENTENCODING", szEnc)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(mt, "CURRENTENCODING"))
		
		IupAppend(TGlobalVariables->tabs,IupBackgroundBox(IupVbox(mt, NULL)))
		
		IupMap(IupGetParent(IupGetParent(mt)))
		
		mtxt_set_attribute_multitext_proc(mt)
		
		Dim As Zstring*1000 sztPath, sztName
		
		If iPosSpl = 0 Then
			
			sztPath = ""
			
		Else
			
			sztPath = Mid(*pszPath,1,iPosSpl)
			
		Endif
		
		sztName = Mid(*pszPath,iPosSpl+1,Len(*pszPath)-iPosSpl)
		
		#ifdef __fb_win32__				
			
			Dim As Integer iSizeTempRet
			
			Dim As Zstring*2 szZero = ""
			
			Dim As Zstring Ptr pszToCode
			
			pszToCode = Cast(Zstring Ptr ,enc_encode_buffer_proc("UTF-8" , szZero , Cast(Byte Ptr,@sztName) , Len(sztName) , iSizeTempRet))		
			
			If pszToCode Then
				
				IupSetStrAttribute(mt, "FILENAMETAB", pszToCode)
				
				Deallocate (pszToCode)
				
			Endif					
			
		#else
			
			IupSetStrAttribute(mt, "FILENAMETAB", sztName )
			
		#endif
		
		Dim As Integer iSizeReturn
		
		Dim As Byte Ptr pbFileToCode
		
		If szEnc = "UTF-8 BOM" Then
			
			pbFileToCode = enc_encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , mt)
			
		Else
			
			pbFileToCode = enc_encode_buffer_proc("UTF-8" , szEnc , pbData , iSizeFile , iSizeReturn , mt)		
			
		Endif
		
		IupSetStrAttribute(mt, "FILEPATH", sztPath)
		
		IupSetStrAttribute(mt, "FILENAME", sztName)
		
		IupSetStrAttribute(mt, "PRGNOACTIVE", "1")
		
		Scope
			
			Dim As String sName = *IupGetAttribute(mt, "FILENAMETAB")
			
			mtxt_set_attribute_for_another_files(mt , sName)
			
		End Scope
		
		Dim As Zstring*1000 szTempBufPath = sztPath & sztName
		
		Dim As Zstring*2 szEncZero = ""
		
		Dim As Integer iSizeRet
		
		Dim As Zstring Ptr pszEncPath = Cast(Zstring Ptr,enc_encode_buffer_proc("UTF-8",Strptr(szEncZero), Cast(Byte Ptr,@szTempBufPath), Len(szTempBufPath) , iSizeRet))
		
		If pszEncPath Then Deallocate (pszEncPath)
		
		TGlobalVariables->tTabsOptions(ic).multitext = mt
		
		IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,IupGetAttribute(mt, "FILENAMETAB"))
		
		Dim As Zstring*20 szRaster = *IupGetAttribute(TGlobalVariables->buildbox, "RASTERSIZE")
		
		IupRefresh(TGlobalVariables->dlg)
		
		IupSetAttribute(TGlobalVariables->buildbox, "RASTERSIZE" , Strptr(szRaster))
		
		IupSetAttribute(TGlobalVariables->hTimer, "RUN", "YES")
		
		If pbFileToCode Then
			
			iUnicode = Cast(Long Ptr,pbFileToCode)[0]
			
			If (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
				IupSetStrAttribute(mt, "VALUE", pbFileToCode+3)
				
			Else
				
				IupSetStrAttribute(mt, "VALUE", pbFileToCode)
				
			Endif
			
		Endif
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
			
			IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
			
		Else
			
			IupScintillaSendMessage(mt, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
			
		Endif			
		
		IupSetAttribute(mt, "ISCHANGES", "NO")
		
		IupScintillaSendMessage(mt, SCI_EMPTYUNDOBUFFER, 0,  0)
		
		If pbFileToCode Then Deallocate (pbFileToCode)
		
		If pbData Then Deallocate (pbData)
		
		IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
		
		Select Case iTypeFile
				
			Case 0
				
				pProject.tBasFiles(iIndexArray).mt = mt
				
			Case 1
				
				pProject.tBiFiles(iIndexArray).mt = mt
				
			Case 2
				
				pProject.tRcFiles(iIndexArray).mt = mt
				
		End Select
		
		if TGlobalVariables->bFlagFolding = 1 then
			
			IupScintillaSendMessage( mt, 4003, 0, cast(any ptr , -1) ) ' SCI_COLOURISE
			
		EndIf
		
	Endif
	
	tb_fill_combobuild_proc()
	
	tmr_update_after_changes()
	
End Sub

Sub fl_re_open_file_proc (pszEnc As Zstring Ptr) Export
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Zstring*1000 szPath = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILEPATH") & _
	*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "FILENAME")
	
	If szPath = "" Then Exit Sub
	
	Dim As Zstring Ptr pszPath  = Strptr( szPath )
	
	Dim iSizeFile As Long
	
	Dim As Byte Ptr pbData = fl_read_file_proc(pszPath , iSizeFile)
	
	Dim As Byte Ptr pbToCode
	
	If pbData <> 0 Then
		
		If *pszEnc = "Default System" Then
			
			*pszEnc = TGlobalVariables->szDefaultSystemEncoding
			
		Endif
		
		Dim As Integer iSizeReturn
		
		If *pszEnc = "UTF-8 BOM" Then
			
			pbToCode = enc_encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , TGlobalVariables->tTabsOptions(idTabs).multitext)	
			
		Else
			
			pbToCode = enc_encode_buffer_proc("UTF-8" , pszEnc , pbData , iSizeFile , iSizeReturn , TGlobalVariables->tTabsOptions(idTabs).multitext)
			
		Endif	
		
		If pbToCode Then
			
			Dim As Long iUnicode = Cast(Long Ptr,pbToCode)[0]
			
			If (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "VALUE", pbToCode+3)
				
			Else
				
				IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "VALUE", pbToCode)
				
			Endif
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_EMPTYUNDOBUFFER, 0,  0) 
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Editor" , "lineends") = "WIN" Then
				
				IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CONVERTEOLS,  SC_EOL_CRLF ,  0 )
				
			Else
				
				IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CONVERTEOLS,  SC_EOL_LF ,  0 )
				
			Endif
			
			IupSetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "ISCHANGES", "NO")
			
			if TGlobalVariables->bFlagFolding = 1 then
				
				IupScintillaSendMessage( TGlobalVariables->tTabsOptions(idTabs).multitext, 4003, 0, cast(any ptr , -1) ) ' SCI_COLOURISE
				
			EndIf
			
		Endif	
		
		if pbToCode then Deallocate (pbToCode)
		
		Deallocate (pbData)
		
	Endif
	
	If pbToCode Andalso *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "AUTOSELENCODING")  <> "1" Then
		
		IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING", pszEnc)
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING"))
		
	Endif
	
	tmr_update_after_changes()
	
End Sub

Sub fl_new_file_proc() Export 
	
	Var mt = IupScintilla()
	
	IupSetStrAttribute(mt, "CURRENTENCODING", TGlobalVariables->szDefaultSystemEncoding)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , TGlobalVariables->szDefaultSystemEncoding)
	
	Var ic = IupGetChildCount(TGlobalVariables->tabs)
	
	IupAppend(TGlobalVariables->tabs,IupBackgroundBox(IupVbox(mt, NULL)))
	
	IupMap(IupGetParent(IupGetParent(mt)))
	
	mtxt_set_attribute_multitext_proc(mt)
	
	IupSetAttribute(mt, "ISCHANGES", "NO")
	
	TGlobalVariables->tTabsOptions(ic).multitext = mt
	
	IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE",ic ,"New")
	
	IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
	
	IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - New")
	
	If IupScintillaSendMessage(mt, SCI_GETEOLMODE, 0  ,  0 ) = SC_EOL_CRLF Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
		
	Endif	
	
	If pProject.iProjectLoad Then
		
		tb_fill_combobuild_proc()
		
	Endif
	
	IupRefresh(TGlobalVariables->dlg)
	
	IupSetFocus(mt)	
	
	tmr_update_after_changes()	
	
End Sub

Sub fl_open_include_files_proc() Export
	
	If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttab"))
		
		Exit Sub
		
	Endif
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	Dim As Integer iPosCaret = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "CARETPOS")
	
	Dim As Integer iLine , iColumn 
	
	Dim As Byte bAbsolutPath
	
	IupTextConvertPosToLinCol(TGlobalVariables->tTabsOptions(idTabs).multitext, iPosCaret, Cast(Any Ptr, @iLine), Cast(Any Ptr, @iColumn))
	
	Dim As String sText = *IupGetAttributeId(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINE", iLine )
	
	sText = Ltrim(sText , Any " " & Chr(9) )
	
	If Left(Lcase(sText), 8 ) = "#include" Then
		
		Dim As Long iFindBeg , iFindEnd
		
		iFindBeg = Instr(sText,Chr(34))
		
		If iFindBeg Then
			
			iFindEnd = Instr(iFindBeg+1,sText,Chr(34))
			
			If iFindEnd Then
				
				sText = Mid(sText,iFindBeg+1,(iFindEnd-iFindBeg)-1)
				
			Else
				
				sText = Mid(sText,iFindBeg+1)
				
			Endif
			
			#ifdef __fb_win32__
				
				sText = misc_replace_string_proc(sText , "/","\",,1)
				
				If Mid(sText , 2, 2) = ":\" Then
					
					bAbsolutPath = 1
					
				Endif
				
			#else
				
				If Left(sText , 1) = "/" Then
					
					bAbsolutPath = 1
					
				Endif
				
			#endif
			
			Dim As String sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext,"FILEPATH")
			
			Dim As Integer iCountTabs = IupGetInt(TGlobalVariables->tabs, "COUNT")
			
			Dim As iHandle Ptr mtReturn
			
			If bAbsolutPath Then
				
				If Fileexists(sText) = -1 Then                                               
					
					Dim As Long iRet = fl_is_fileproject_to_open_proc(sText , mtReturn)
					
					If iRet = 1 Then
						
						fl_save_project_proc(0)
						
						If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
							
							winside_addInfo_prj_inlist_proc()
							
						Endif
						
					Elseif iRet = 0 Then
						
						fl_open_file_proc(sText)
						
					Else
						
						For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
							
							If TGlobalVariables->tTabsOptions(j).multitext = mtReturn Then
								
								IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
								
								IupSetFocus(TGlobalVariables->tTabsOptions(j).multitext)
								
								Exit Sub
								
							Endif
							
						Next
						
					Endif
					
					IupSetFocus(TGlobalVariables->tTabsOptions(iCountTabs).multitext)
					
					Exit Sub
					
				Endif         	
				
			Elseif Len(sPathCurent) Then
				
				'sPathCurent = enc_encode_path_proc(sPathCurent , 0)
				
				sPathCurent = sPathCurent & sText                  
				
				If Fileexists(sPathCurent) = -1 Then                                               
					
					Dim As Long iRet = fl_is_fileproject_to_open_proc(sPathCurent , mtReturn)
					
					If iRet = 1 Then
						
						fl_save_project_proc(0)
						
						If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then
							
							winside_addInfo_prj_inlist_proc()
							
						Endif
						
					Elseif iRet = 0 Then
						
						fl_open_file_proc(sPathCurent)
						
					Else
						
						For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
							
							If TGlobalVariables->tTabsOptions(j).multitext = mtReturn Then
								
								IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
								
								IupSetFocus(TGlobalVariables->tTabsOptions(j).multitext)
								
								Exit Sub
								
							Endif
							
						Next						
						
					Endif
					
					IupSetFocus(TGlobalVariables->tTabsOptions(iCountTabs).multitext)
					
					Exit Sub
					
				Endif
				
			Endif 
			
			sPathCurent = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Path","pathinclude")
			
			If Len(sPathCurent) Then
				
				If Left(sPathCurent , 2) = "$A" Then
					
					sPathCurent = Exepath() & Mid( sPathCurent , 3)
					
				Endif  
				
				sPathCurent = enc_encode_path_proc(sPathCurent , 0)
				
				If Right(sPathCurent,1) <> "\" Andalso Right(sPathCurent,1) <> "/" Then
					
					#ifdef __fb_win32__
						
						sPathCurent = sPathCurent & "\"
						
					#else
						
						sPathCurent = sPathCurent & "/"
						
					#endif
					
				Endif
				
				sPathCurent = sPathCurent & sText                  
				
				If Fileexists(sPathCurent) = -1 Then                                               
					
					fl_open_file_proc(sPathCurent)
					
					IupSetFocus(TGlobalVariables->tTabsOptions(iCountTabs).multitext)
					
				Endif                     
				
			Endif
			
		Endif
		
	Endif
	
End Sub

Sub fl_checkpath_and_create_folder(sDirProject As String , sPartName As String , sSep As String)
	
	Dim As Long iFindSep , iFindNext = 1
	
	Dim As String sTempDir = sDirProject
	
	While 1
		
		iFindSep = Instr(iFindNext , sPartName , sSep)
		
		If iFindSep Then
			
			sTempDir = sDirProject & Mid(sPartName , 1 , iFindSep-1)
			
			Mkdir(sTempDir)
			
			iFindNext = iFindSep + 1
			
		Else
			
			Exit While
			
		Endif
		
	Wend
	
End Sub

Sub fl_new_file_project_proc(sFileName As String , iTypeFile As Long , iFlagExisting As Long  = 0) Export 'iTypeFile: 0 - module , 1 -headers , 2 - res
	
	Dim As Long iIndex
	
	For i As Long = 0 To 1001
		
		If i > 1000 Then
			
			IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
			*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjcount"))			
			
			Exit Sub
			
		Endif
		
		Select Case iTypeFile
				
			Case 0
				
				If pProject.tBasFiles(i).pszFile = 0 Then
					
					iIndex = i
					
					pProject.tBasFiles(i).pszFile = Callocate(Len(sFileName)+1)
					
					if pProject.tBasFiles(i).pszFile = 0 then
						
						winout_error_memory_proc()
						
						exit sub
						
					EndIf
					
					*(pProject.tBasFiles(i).pszFile) = sFileName
					
					Exit For
					
				Endif
				
			Case 1
				
				If pProject.tBiFiles(i).pszFile = 0 Then
					
					iIndex = i
					
					pProject.tBiFiles(i).pszFile = Callocate(Len(sFileName)+1)
					
					if pProject.tBiFiles(i).pszFile = 0 then
						
						winout_error_memory_proc()
						
						exit sub
						
					EndIf
					
					*(pProject.tBiFiles(i).pszFile) = sFileName
					
					Exit For
					
				Endif
				
			Case 2
				
				If i > 100 Then
					
					IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
					*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgprjcount"))
					
					Exit Sub
					
				Endif
				
				If pProject.tRcFiles(i).pszFile = 0 Then
					
					iIndex = i
					
					pProject.tRcFiles(i).pszFile = Callocate(Len(sFileName)+1)
					
					if pProject.tRcFiles(i).pszFile = 0 then
						
						winout_error_memory_proc()
						
						exit sub
						
					EndIf
					
					*(pProject.tRcFiles(i).pszFile) = sFileName
					
					Exit For
					
				Endif
				
		End Select
		
	Next
	
	#ifdef __fb_win32__			
		Dim As String sSep = "\"
	#else
		Dim As String sSep = "/"
	#endif
	
	Dim As String sPathDir = *(pProject.pszPathProject) & sSep
	
	Dim As String sPathFile
	
	fl_checkpath_and_create_folder(sPathDir , sFileName , sSep)
	
	sPathFile = sPathDir & sFileName
	
	Dim As Byte Ptr pbData
	
	Dim iSizeFile As Long
	
	If iFlagExisting = 0 Then
		
		Dim As Integer id = Freefile
		
		Open sPathFile For Binary As #id
		
		If Err <> 0 Then
			
			Select Case iTypeFile
					
				Case 0
					
					If pProject.tBasFiles(iIndex).pszFile Then 
						
						Deallocate(pProject.tBasFiles(iIndex).pszFile)
						
						pProject.tBasFiles(iIndex).pszFile = 0
						
					Endif
					
				Case 1
					
					If pProject.tBiFiles(iIndex).pszFile Then 
						
						Deallocate(pProject.tBiFiles(iIndex).pszFile)
						
						pProject.tBiFiles(iIndex).pszFile = 0
						
					Endif
					
				Case 2
					
					If pProject.tRcFiles(iIndex).pszFile Then 
						
						Deallocate(pProject.tRcFiles(iIndex).pszFile)
						
						pProject.tRcFiles(iIndex).pszFile = 0
						
					Endif
					
			End Select
			
			Exit Sub
			
		Endif
		
		Select Case *(pProject.pszEncProject)
				
			Case "UTF-32LE" , "UCS-4LE" , "UTF-32","UCS-4","UCS-4-INTERNAL"
				
				Dim As Long p = &hFEFF
				
				Put #id , 1 , p
				
			Case "UTF-32BE","UCS-4BE"
				
				Dim As Long p = &hFFFE0000
				
				Put #id , 1 , p
				
			Case "UTF-16LE" , "UCS-2LE" , "UTF-16" , "UCS-2" , "UCS-2-INTERNAL"
				
				Dim As Short p = &hFEFF
				
				Put #id , 1 , p
				
			Case "UTF-16BE" , "UCS-2BE"
				
				Dim As Short p = &hFFFE
				
				Put #id , 1 , p
				
			Case "UTF-8 BOM"
				
				Dim As String s = Chr(&hEF,&hBB,&hBF)
				
				Put #id , 1 , s
				
		End Select
		
		Close #id
		
	Else
		
		pbData = fl_read_file_proc(sPathFile , iSizeFile)
		
	Endif
	
	If IupGetChildCount(TGlobalVariables->tabs) > 98 Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorendtitle"), _
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgerrorcounttabprj"))
		
		Exit Sub
		
	Endif
	
	Var mt = IupScintilla()
	
	IupSetStrAttribute(mt, "CURRENTENCODING", pProject.pszEncProject)
	
	IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "ENCLBL"), "TITLE" , pProject.pszEncProject)
	
	Var ic = IupGetChildCount(TGlobalVariables->tabs)
	
	IupAppend(TGlobalVariables->tabs,IupBackgroundBox(IupVbox(mt, NULL)))
	
	IupMap(IupGetParent(IupGetParent(mt)))
	
	mtxt_set_attribute_multitext_proc(mt)
	
	IupSetAttribute(mt, "ISCHANGES", "NO")
	
	TGlobalVariables->tTabsOptions(ic).multitext = mt
	
	Select Case iTypeFile
			
		Case 0
			
			pProject.tBasFiles(iIndex).mt = mt
			
		Case 1
			
			pProject.tBiFiles(iIndex).mt = mt
			
		Case 2
			
			pProject.tRcFiles(iIndex).mt = mt
			
	End Select	
	
	Dim As String sFileTab
	
	#ifdef __fb_win32__
		
		sFileTab = enc_encode_path_proc(sFileName, 1)
		
		sPathFile = enc_encode_path_proc(sPathFile, 1)	
		
		IupSetStrAttribute(TGlobalVariables->tTabsOptions(ic).multitext, "FILENAMETAB", Strptr(sFileTab) )
		
	#else	
		
		IupSetStrAttribute(TGlobalVariables->tTabsOptions(ic).multitext, "FILENAMETAB", Strptr(sFileName) )
		
	#endif
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(ic).multitext, "FILEPATH", Strptr(sPathDir))
	
	IupSetStrAttribute(TGlobalVariables->tTabsOptions(ic).multitext, "FILENAME", Strptr(sFileName))
	
	Scope
		
		Dim As String sName = *IupGetAttribute(mt, "FILENAMETAB")
		
		mtxt_set_attribute_for_another_files(mt , sName)
		
	End Scope
	
	If iFlagExisting Andalso pbData Then
		
		Dim As Integer iSizeReturn
		
		Dim As Byte Ptr pbFileToCode
		
		If *(pProject.pszEncProject) = "UTF-8 BOM" Then
			
			pbFileToCode = enc_encode_buffer_proc("UTF-8" , "UTF-8" , pbData , iSizeFile , iSizeReturn , 0 , 1)
			
		Else
			
			pbFileToCode = enc_encode_buffer_proc("UTF-8" , pProject.pszEncProject , pbData , iSizeFile , iSizeReturn , 0 , 1)
			
		Endif
		
		If pbFileToCode Then
			
			Dim As Long iUnicode = Cast(Long Ptr,pbFileToCode)[0]
			
			If (iUnicode And &hFFFFFF) = &hBFBBEF Then
				
				IupSetStrAttribute(mt, "VALUE", pbFileToCode+3)
				
			Else
				
				IupSetStrAttribute(mt, "VALUE", pbFileToCode)
				
			Endif
			
			Deallocate(pbFileToCode)
			
		Endif
		
		Deallocate(pbData)
		
	Endif
	
	IupSetAttributeId(TGlobalVariables->tabs, "TABTITLE", ic ,IupGetAttribute(TGlobalVariables->tTabsOptions(ic).multitext, "FILENAMETAB"))
	
	IupSetStrAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor - " & sPathFile)
	
	IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(ic))
	
	If IupScintillaSendMessage(mt, SCI_GETEOLMODE, 0  ,  0 ) = SC_EOL_CRLF Then
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: WIN (CRLF)")
		
	Else
		
		IupSetAttribute(IupGetDialogChild(TGlobalVariables->dlg, "EOLLBL"), "TITLE" , "EOL: UNIX (LF)")
		
	Endif	
	
	IupRefresh(TGlobalVariables->dlg)
	
	IupSetFocus(mt)	
	
	tmr_update_after_changes()	
	
End Sub

Function fl_save_project_proc(iNew As Long , sOldName As String  = "" , dlg as Ihandle ptr = 0) As Long Export
	
	Dim id As Integer
	
	#ifdef __fb_win32__
		
		Dim As String sSep = "\"
		
		Dim As String sPathDir = *(pProject.pszPathProject)
		
		Dim As String sPathFile = sPathDir & sSep & *(pProject.pszNameProject)
		
	#else
		
		Dim As String sSep = "/"
		
		Dim As String sPathDir = *(pProject.pszPathProject)
		
		Dim As String sPathFile = sPathDir & sSep & *(pProject.pszNameProject)
		
		sPathDir = enc_encode_path_proc(sPathDir, 0)
		
		sPathFile = enc_encode_path_proc(sPathFile, 0)
		
	#endif
	
	If Len(sPathDir) Andalso Len(sPathFile) Then
		
		If iNew Then
			
			If Mkdir(sPathDir) <> 0 Then
				
				msdlg_dialog_message_yes_no_proc(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning"),_
				*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgpatherror"),_
				1 , dlg)
				
				Return 0
				
			Endif
			
			fl_new_file_project_proc(*(pProject.pszNameProject) & ".bas" , 0)
			
		Endif
		
		If Fileexists(sPathFile & ".prj") Then
			
			Kill (sPathFile & ".prj")
			
		Endif
		
		id = Freefile
		
		If Len(sOldName) Then
			
			Dim As String sOldFilePathProject = sPathDir & sSep & sOldName & ".prj"
			
			If Fileexists(sOldFilePathProject) Then
				
				Kill (sOldFilePathProject)
				
			Endif
			
			Open sOldFilePathProject For Binary As #id
			
		Else
			
			Open sPathFile & ".prj" For Binary As #id
			
		Endif
		
		If Err <> 0 Then Return 0
		
		Dim As String sOpenFileInEditorBit
		
		Put #id, , *(pProject.pszNameProject)
		
		Put #id, , Chr(10)
		
		Put #id, , *(pProject.pszParamProject)
		
		Put #id, , Chr(10)
		
		Put #id, , *(pProject.pszEncProject)
		
		Put #id, , Chr(10)
		
		For i As Long = 0 To 1000
			
			If pProject.tBasFiles(i).pszFile Then
				
				Put #id, , *(pProject.tBasFiles(i).pszFile) & "|"
				
				If pProject.tBasFiles(i).mt Then
					
					sOpenFileInEditorBit & = 1
					
				Else
					
					sOpenFileInEditorBit & = 0
					
				Endif
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Put #id, , Chr(10)
		
		Put #id, , sOpenFileInEditorBit
		
		Put #id, , Chr(10)
		
		sOpenFileInEditorBit = ""
		
		For i As Long = 0 To 1000
			
			If pProject.tBiFiles(i).pszFile Then
				
				Put #id, , *(pProject.tBiFiles(i).pszFile) & "|"
				
				If pProject.tBiFiles(i).mt Then
					
					sOpenFileInEditorBit & = 1
					
				Else
					
					sOpenFileInEditorBit & = 0
					
				Endif				
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Put #id, , Chr(10)
		
		Put #id, , sOpenFileInEditorBit
		
		Put #id, , Chr(10)
		
		sOpenFileInEditorBit = ""
		
		For i As Long = 0 To 100
			
			If pProject.tRcFiles(i).pszFile Then
				
				Put #id, , *(pProject.tRcFiles(i).pszFile) & "|"
				
				If pProject.tRcFiles(i).mt Then
					
					sOpenFileInEditorBit & = 1
					
				Else
					
					sOpenFileInEditorBit & = 0
					
				Endif
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		Put #id, , Chr(10)
		
		Put #id, , sOpenFileInEditorBit
		
		Put #id, , Chr(10)		
		
		Put #id, , Str(pProject.iCurentMainFile)
		
		Put #id, , Chr(10)
		
		Close #id
		
		If Len(sOldName) Andalso sOldName <> *(pProject.pszNameProject) Then
			
			#ifdef __fb_win32__
				
				fl_rename_file(sPathDir & sSep & sOldName & ".prj" , sPathFile & ".prj")
				
			#else
				
				Dim As String sOldTemp , sNewTemp
				
				sOldTemp = misc_replace_string_proc(sPathDir & sSep & sOldName & ".prj" , " " , "\ " ,  , 1)
				
				sNewTemp = misc_replace_string_proc(sPathFile & ".prj" , " " , "\ " ,  , 1)				
				
				fl_rename_file(sOldTemp , sNewTemp)
				
			#endif
			
		Endif
		
		Return 1
		
	Endif
	
End Function

Sub fl_delete_folder_proc(sDir As String)
	
	#ifdef __fb_win32__
		
		Dim As String*3000 sFrom = sDir+Chr(0)
		Dim As SHFILEOPSTRUCT op
		ZeroMemory(@op, Sizeof(op))
		op.hwnd  = 0
		op.wFunc = FO_DELETE
		op.pFrom = Cast(LPCSTR,Strptr(sFrom))
		op.pTo   = 0
		op.fFlags= FOF_NOCONFIRMATION
		SHFileOperation( @op)
		
	#else	
		
		Dim As String sTempDir = sDir
		
		sTempDir = misc_replace_string_proc(sTempDir , " " , "\ " ,  , 1)
		
		Shell("rm -r " & sTempDir)
		
	#endif
	
End Sub

Sub fl_rename_file(sSource As String , sDest As String)
	
	#ifdef __fb_win32__
		
		Dim As SHFILEOPSTRUCT op
		ZeroMemory(@op, Sizeof(SHFILEOPSTRUCT))
		op.hwnd  = 0
		op.wFunc = FO_RENAME
		op.fFlags= 0	
		Dim As String*3000 sFrom = sSource + Chr(0)
		Dim As String*3000  sTo   = sDest + Chr(0)	
		op.pFrom = Cast(LPSTR,@sFrom)
		op.pTo   = Cast(LPSTR,@sTo)
		SHFileOperation( @op)
		
	#else	
		
		Shell("mv " & sSource & " " & sDest)
		
	#endif
	
End Sub

Function fl_is_fileproject_to_open_proc(sFullPath As String , Byref mt As ihandle Ptr) As Long
	
	Dim As String sName , sPath , sSep 
	
	Dim As Long iTempSep , iFlagOpenProject
	
	#ifdef __fb_win32__
		
		sSep = "\"
		
	#else
		
		sSep = "/"
		
	#endif
	
	iTempSep = Instrrev(sFullPath , sSep)
	
	sPath = Left(sFullPath , iTempSep-1)
	
	sName = Mid(sFullPath , iTempSep+1)
	
	If sPath = *pProject.pszPathProject Then
		
		For i As Long = 0 To 1000
			
			If pProject.tBasFiles(i).pszFile Then
				
				If *(pProject.tBasFiles(i).pszFile) = sName Then
					
					If pProject.tBasFiles(i).mt = 0 Then
						
						fl_open_file_project_proc(sPath & sSep & sName , 0 , i)
						
						Return 1
						
					Else
						
						mt = pProject.tBasFiles(i).mt
						
						Return 2
						
					Endif
					
				Endif
				
			Endif
			
		Next
		
		If iFlagOpenProject = 0 Then
			
			For i As Long = 0 To 1000
				
				If pProject.tBiFiles(i).pszFile Then
					
					If *(pProject.tBiFiles(i).pszFile) = sName Then
						
						If pProject.tBiFiles(i).mt = 0 Then
							
							fl_open_file_project_proc(sPath & sSep & sName , 1 , i)
							
							Return 1
							
						Else
							
							mt = pProject.tBiFiles(i).mt
							
							Return 2
							
						Endif
						
					Endif
					
				Endif
				
			Next
			
		Endif
		
	Endif	
	
End Function