Function hlp_trim_path(sPath As String) As String
	
	Dim As Long iPos = Instr(Trim(sPath) , "-e ")
	
	If iPos Then
		
		Dim As String sRetPath
		
		If iPos = 1 Then
			
			sRetPath = Ltrim(Mid(sPath , iPos+3))
			
			iPos = Instr(sRetPath , " ")
			
			If iPos Then
				
				Return Ltrim(Mid(sRetPath , iPos+1))
				
			Else
				
				Return sPath
				
			Endif
			
		Else
			
			Return Trim(Mid(sPath , 1 , iPos-1))
			
		Endif
		
	Else
		
		Return sPath
		
	Endif
	
End Function

Sub hlp_execute_default_chm_proc(sParam As String)
	
	Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF","c1")
	
	If Len(sPath) Then
		
		#ifdef __fb_win32__
			
			If Len(sParam) Then
				
				hlp_OpenHelp_proc(sPath , sParam , 2)
				
			Else
				
				IupExecute(sPath, 0)
				
			Endif
			
		#else
			
			sPath = enc_encode_path_proc(sPath , 0)
			
			sPath = misc_replace_string_proc(sPath ,  "$A" , Exepath())
			
			Dim As String szPathParam = hlp_trim_path(sPath)
			
			Dim As String szPathParamCopy = szPathParam
			
			szPathParam = misc_replace_string_proc(szPathParam , " " , "\ " , , 1)
			
			sPath = misc_replace_string_proc(sPath , szPathParamCopy , szPathParam )            
			
			IupExecute(misc_replace_string_proc(Exepath , " " , "\ " , , 1) & "/tools/chmviewer/CHMVIEW", sParam & sPath)
			
		#endif
		
	Endif
	
End Sub

Function hlp_getword_proc() As Zstring Ptr Export
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Return 0
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS")) 
	
	Dim As Ihandle Ptr mt = TGlobalVariables->tTabsOptions(idTabs).multitext  
	
	Dim As Integer iPos1 , iPos2 , iCurPos
	
	Dim As Zstring Ptr pszBuf
	
	iCurPos = Cint(IupScintillaSendMessage(mt , SCI_GETCURRENTPOS , 0 , 0 ))
	
	iPos1 = Cint(IupScintillaSendMessage( mt, SCI_WORDSTARTPOSITION, iCurPos, Cast(Any Ptr,-1)))
	
	iPos2 = Cint(IupScintillaSendMessage( mt, SCI_WORDENDPOSITION, iCurPos, Cast(Any Ptr,0)))
	
	If iPos2 > iPos1 Then
		
		Dim tr  As SCI_TEXTRANGE
		
		tr.chrg.cpMin = iPos1
		
		tr.chrg.cpMax = iPos2 
		
		pszBuf = Callocate((iPos2 - iPos1) + 2)
		
		if pszBuf = 0 then
			
			winout_error_memory_proc()
			
			return 0
			
		EndIf
		
		tr.lpstrText = pszBuf
		
		IupScintillaSendMessage( mt, SCI_GETTEXTRANGE, 0, Cast(Any Ptr, @tr)) 
		
		Return pszBuf
		
	Endif
	
End Function

#ifdef __fb_win32__
	' code from library window9 , edited for 64x-bit
	Enum eHelp
		HH_DISPLAY_TOPIC  = 0
		HH_DISPLAY_TOC    = 1
		HH_DISPLAY_INDEX  = 2
		HH_KEYWORD_LOOKUP = 13
		HH_HELP_CONTEXT =   15
		HH_CLOSE_ALL      = 18
	End Enum
	
	#ifndef HH_AKLINK
		Type HH_AKLINK
			cbStruct      As Long
			fReserved     As Boolean
			pszKeywords   As Zstring Ptr
			pszUrl        As Zstring Ptr
			pszMsgText    As Zstring Ptr
			pszMsgTitle   As Zstring Ptr
			pszWindow     As Zstring Ptr
			fIndexOnFail  As Boolean
		End Type
	#endif
	
	Type THelp
		Memdll As Any Ptr
		HtmlHelp As Function ( Byval hwndCaller As HWND, pszFile As Zstring Ptr,_
		Byval uCommand As Long, Byval dwData As Long Ptr) As HWND
		bFlag As BOOL
	End Type
	
	Dim Shared tHelp As THelp
	
	Function hlp_OpenHelp_proc(szPathHelp As String ,szTopic As String , iParam As Integer ) As HWND Export 
		
		If tHelp.bFlag = False Then
			
			tHelp.bFlag = True
			
			tHelp.Memdll=Dylibload("hhctrl.ocx")
			
			If tHelp.Memdll=0 Then
				
				Print "Error Load hhctrl.ocx"
				
				Return 0
				
			Endif
			
			tHelp.HtmlHelp=Dylibsymbol(tHelp.Memdll, "HtmlHelpA")
			
			If tHelp.HtmlHelp = 0 Then
				
				Print "Error Get HtmlHelpA"
				
				Return 0
				
			Endif
			
		Endif
		
		Dim HHAKLINK As HH_AKLINK
		
		HHAKLINK.cbStruct = Sizeof(HH_AKLINK)
		
		HHAKLINK.pszKeywords = Strptr(szTopic)
		
		HHAKLINK.fIndexOnFail = True
		
		Select Case iparam
				
			Case 1
				
				Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long Ptr,@HHAKLINK)))
				
			Case 2
				
				tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_TOC,Cast(Long Ptr,Strptr(szTopic)))
				
				Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long Ptr,@HHAKLINK)))
				
			Case 3
				
				tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_INDEX,Cast(Long Ptr,Strptr(szTopic)))
				
				Return Cast(HWND,tHelp.HtmlHelp(0,szPathHelp,HH_KEYWORD_LOOKUP,Cast(Long Ptr,@HHAKLINK)))
				
			Case Else
				
				Return Cast(HWND, tHelp.HtmlHelp(0,szPathHelp,HH_DISPLAY_TOPIC,Cast(Long Ptr,Strptr(szTopic))))
				
		End Select
		
	End Function
	
	Sub hlp_CloseHelp_proc() Export 
		
		If tHelp.bFlag = True Then tHelp.HtmlHelp(0,0,HH_CLOSE_ALL,0)
		
		Sleep(50)
		
		If tHelp.bFlag = True Then Dylibfree tHelp.Memdll
		
		tHelp.bFlag = False
		
	End Sub
	
	Sub hlp_CloseHelpBeforeStart_proc() Export 
		
		If tHelp.bFlag = True Then tHelp.HtmlHelp(0,0,HH_CLOSE_ALL,0)
		
		Sleep(100)
		
	End Sub	
	
	Sub hlp_execute_default_chm_win_proc(sParam As String)
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF","c1")
		
		If Len(sPath) Then
			
			hlp_OpenHelp_proc(sPath , sParam , 2)
			
		Endif
		
	End Sub
	
#endif

Sub hlp_processing_f1_proc() Export
	
	Dim As Zstring Ptr pszBuf = hlp_getword_proc()
	
	Dim As String sKeyWord
	
	If pszBuf > 0  Then
		
		If Len(*pszBuf)>1 Then
			
			sKeyWord = Trim(*pszBuf, Any Chr(13) & Chr(10) & Chr(32))
			
		Endif
		
		Deallocate(pszBuf)
		
		If Len(sKeyWord)>1 Then
			
			Dim As Long iIndexH = chm_compare_help_keywords_proc(Lcase(sKeyWord))
			
			If iIndexH Then
				
				If pArrayTHelpList(iIndexH).pFirst Andalso (pArrayTHelpList(iIndexH).pFirst)->psz Then
					
					Dim As String sPath = *((pArrayTHelpList(iIndexH).pFirst)->psz)
					
					If Len(sPath) Then
						
						#ifdef __fb_win32__
							
							hlp_CloseHelpBeforeStart_proc()
							
							hlp_OpenHelp_proc(sPath , sKeyWord , 2)
							
						#else
							
							Dim As String szExePath = hlp_trim_path(sPath)
							
							Dim As String szExePathCopy = szExePath
							
							szExePath = misc_replace_string_proc(szExePath , " " , "\ " , , 1)
							
							sPath = misc_replace_string_proc(sPath , szExePathCopy , szExePath )
							
							IupExecute(misc_replace_string_proc(Exepath , " " , "\ " , , 1) & "/tools/chmviewer/CHMVIEW",_
							" -k " & sKeyWord & " " & sPath)
							
						#endif
						
					Endif
					
				Endif
				
			Else
				
				#ifdef __fb_win32__
					
					hlp_execute_default_chm_proc(sKeyWord)
					
				#else    
					
					hlp_execute_default_chm_proc(" -k " & sKeyWord & " ")
					
				#endif
				
			Endif
			
		Else
			
			hlp_execute_default_chm_proc("")
			
		Endif   
		
	Else
		
		hlp_execute_default_chm_proc("")
		
	Endif
	
End Sub

Sub hlp_enum_keywords_helps(p As Any Ptr)
	
	For i As Long = 1 To 100
		
		pArrayTHelpList(i).delAll()
		
	Next
	
	Redim As THELPLIST pArrayTHelpList(1 To 100)
	
	For i As Long = 1 To 100
		
		Dim As String sPath = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"HELPF","c" & i)
		
		If Len(sPath) Then
			
			sPath = enc_encode_path_proc(sPath , 0)
			
			sPath = misc_replace_string_proc(sPath ,  "$A" , Exepath())
			
			If Len(sPath) Then
				
				pArrayTHelpList(i).addLast(sPath)
				
				chm_enum_keywords_proc(hlp_trim_path(sPath) , i)
				
			Endif
			
		Else
			
			Exit For
			
		Endif
		
	Next
	
End Sub