#Include "../tlist.bi"
#include "../declarations.bi"

dim shared as T_GlobalVariables Ptr TGlobalVariablesDll

Dim Shared As Integer HG_emphasiscolor=&h00FFFF
Dim Shared As Integer HG_alphablending=&h40
Dim Shared As Integer HG_updatedelay=100


' jepalza , necesarios en scintilla
#Define SCI_SETINDICATORCURRENT 2500
#Define SCI_GETINDICATORCURRENT 2501
#Define SCI_SETINDICATORVALUE 2502
#Define SCI_GETINDICATORVALUE 2503
#Define SCI_INDICATORFILLRANGE 2504
#Define SCI_INDICATORCLEARRANGE 2505

#define SCI_INDICSETSTYLE 2080
#define SCI_INDICSETFORE 2082
#define SCI_INDICSETUNDER 2510
#define SCI_INDICSETALPHA 2523

#define INDIC_PLAIN 0
#define INDIC_SQUIGGLE 1
#define INDIC_TT 2
#define INDIC_DIAGONAL 3
#define INDIC_STRIKE 4
#define INDIC_HIDDEN 5
#define INDIC_BOX 6
#define INDIC_ROUNDBOX 7
#Define INDIC_CONTAINER 8

'jepalza: marcado de palabras coincidentes
Sub marcado_de_palabras_iguales2()
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariablesDll->tabs, "VALUEPOS"))
	if idTabs = 0 then exit sub 
	Dim As iHandle Ptr ih=TGlobalVariablesDll->tTabsOptions(idTabs).multitext ' manejador al texto 
	if ih = 0 then exit sub
	
	' antes de hacer ninguna otras cosa, borramos los posibles anteriores marcadores   	
	Dim As Integer CurrentIndicator=8 ' cualquiera entre 1 y 31
	
	' caracteres en el fichero (total de bytes que ocupan)
	Dim as Long iLenDoc = IupGetInt(ih, "COUNT")
	
	
	' borra los anteriores marcadores nada mas entrar
	IupScintillaSendMessage( ih , SCI_SETINDICATORCURRENT , CurrentIndicator , 0) ' indicador 8
	IupScintillaSendMessage( ih , SCI_INDICATORCLEARRANGE , 0 , Cast(ZString ptr,cint(iLenDoc)) ) ' total de caracteres del fichero
	
	
	' coge el texto seleccionado 
	Dim As string sSelectionText = *IupGetAttribute(ih, "SELECTEDTEXT")
	If sSelectionText="" Then Exit Sub ' en caso de no haber seleccionado nada, sale
	if trim(sSelectionText)="" then Exit Sub ' si solo se seleccionan espacios vacios, salimos
	
	Dim As Integer iLenFind=Len(sSelectionText) ' longitud del texto (se puede con scintilla, pero vale asi)
	
	' coge el inicio y final del texto seleccionado
	Dim As Integer cpMin=CInt(IupScintillaSendMessage( ih , SCI_GETSELECTIONSTART , 0 , 0))
	Dim As Integer cpMax=CInt(IupScintillaSendMessage( ih , SCI_GETSELECTIONEND , 0 , 0))
	'Dim As Integer iLenFind=cpMax-cpMin ' longitud del texto
	
	''''si queremos mantener el estilo al seleccionar
	''''Dim As integer selectedStyle = CInt(IupScintillaSendMessage( ih , SCI_GETSTYLEAT , cpMin , 0)) ' coge el estilo del texto seleccionado
	
	Dim As Integer style = -1
	Dim As Integer offset = 0
	
	'IupScintillaSendMessage( ih , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)  '&h00100002 
	IupScintillaSendMessage( ih , SCI_SETTARGETSTART, offset,0)
	IupScintillaSendMessage( ih , SCI_SETTARGETEND, iLenDoc,0)
	Dim As integer indexOf = Cint(IupScintillaSendMessage( ih , SCI_SEARCHINTARGET , iLenFind , StrPtr(sSelectionText) )) 
	
	While (indexOf <> -1) 	
		''''style = CInt(IupScintillaSendMessage( ih , SCI_GETSTYLEAT, indexOf,0))
		''''If (selectedStyle = style) Then ' hay coincidencia
			IupScintillaSendMessage( ih , SCI_SETINDICATORCURRENT, CurrentIndicator,Cast(ZString ptr,0) ) ' INDICADOR 8 (PUEDE SER 1)
			IupScintillaSendMessage( ih , SCI_INDICSETALPHA, CurrentIndicator, Cast(ZString ptr,HG_alphablending) ) ' TRANSPARENCIA
			IupScintillaSendMessage( ih , SCI_INDICSETSTYLE, CurrentIndicator, Cast(ZString ptr,INDIC_CONTAINER) ) ' TIPO 8=CAJA
			IupScintillaSendMessage( ih , SCI_INDICSETFORE, CurrentIndicator, Cast(ZString ptr,HG_emphasiscolor) ) ' AMARILLO
			IupScintillaSendMessage( ih , SCI_INDICATORFILLRANGE, IndexOf, Cast(ZString ptr,iLenFind) ) ' INICIO + LONG. DEL TEXTO
		''''End If
		offset = indexOf + iLenFind ' busca el siguiente
		IupScintillaSendMessage( ih , SCI_SETTARGETSTART, offset,0)
		IupScintillaSendMessage( ih , SCI_SETTARGETEND, iLenDoc,0)
		indexOf = Cint(IupScintillaSendMessage( ih , SCI_SEARCHINTARGET , iLenFind , StrPtr(sSelectionText) )) 
	Wend
	
End Sub


Function marcado_de_palabras_iguales_CALLBACK Cdecl (ih As Ihandle Ptr) As Integer
	
	'IupMessage("Informacion","Marcador de palabras")
	marcado_de_palabras_iguales2()
	
	return IUP_DEFAULT
End Function

function InitPluginProc(TGlobalVariables as T_GlobalVariables Ptr , pszDimErrors() as zstring ptr , bEncodingBool() as byte , szEncodingString as any ptr) as Integer Export
	
	if TGlobalVariables = 0 then return 0
	
	TGlobalVariablesDll = TGlobalVariables
	
	
	#ifdef __FB_WIN32__
		dim as string sSep = "\"
	#else
		dim as string sSep = "/"
	#EndIf
	
	dim as string sFileIniPath = exepath & sSep & "plugins" & sSep & "plug_highlight_coincidences.ini"
	
	dim f as Integer = FreeFile
	
	if FILEEXISTS(sFileIniPath) then ' if the settings file exists
		
		open sFileIniPath for input As f
		Dim As String sBuffer
		Line Input #f, sBuffer
		Line Input #f, sBuffer
		Close f
		HG_emphasiscolor=Val(sBuffer):sbuffer=Mid(sBuffer,InStr(sBuffer,",")+1)
		HG_alphablending=Val(sBuffer):sbuffer=Mid(sBuffer,InStr(sBuffer,",")+1)
		HG_updatedelay=Val(sBuffer)
		
	else ' the first run of the plugin and the settings file does not exist yet
		
		open sFileIniPath for Output As f
		Dim As String sBuffer
		sBuffer = "; emphasis color, alpha blending, update delay ms."
		Print #f, sBuffer
		sBuffer = "&h00FFFF,&h40,100"
		Print #f, sBuffer
		Close f
		
	EndIf
	
	
	'dim as ihandle ptr pPlugItem = IupItem("HighLigthing Matches", NULL)
	'IupSetCallback (pPlugItem, "ACTION", Cast(Any Ptr,@marcado_de_palabras_iguales_CALLBACK()))
	'Dim as ihandle ptr hItemEdit = IupGetChild(IupGetChild(main_menu, 1),0)
	'IupAppend( hItemEdit, pPlugItem )
	'IupMap(pPlugItem)
	
	dim as zstring*10 szHG_updatedelay = str(HG_updatedelay)
	Dim As Ihandle Ptr hTimer = IUPtimer()
	IupSetAttribute(hTimer, "TIME", @szHG_updatedelay) ' solo cada 0,1 segundos, para evitar el colapso
	IupSetCallback (hTimer, "ACTION_CB", Cast(Any Ptr,@marcado_de_palabras_iguales_CALLBACK() ))
	IupSetAttribute(hTimer, "RUN", "YES")
	'IupMap(hTimer)
	
	return 1	
End Function
