Declare Function enc_encode_path_proc(sPath As String , iParamUtf As Long) As String
declare sub winout_error_memory_proc()

Type Tlistnode
	
	As Zstring Ptr pszCommand
	
	As Zstring Ptr pszName
	
	As Tlistnode Ptr pNext
	
	As Tlistnode Ptr pPrev
	
End Type

Type Tlist
	
	Declare Sub insert( iIndex As Integer , pszCommand As Zstring Ptr , pszName As Zstring Ptr )
	
	Declare Function del( iIndex As Integer ) As Integer
	
	Declare Sub delAll()
	
	Declare Function Move( iIndexFrom As Long  , iIndexIn As Long) As Integer
	
	Declare Function getNode(iIndex As Long) As Tlistnode Ptr
	
	Declare Function count() As Long
	
	As Tlistnode Ptr pFirst
	
End Type

Function Tlist.count() As Long
	
	Dim As Tlistnode Ptr pTemp = pFirst
	
	Dim As Long iListIndex
	
	While pTemp
		
		iListIndex+=1
		
		pTemp = pTemp->pNext
		
	Wend
	
	Return iListIndex
	
End Function

Function Tlist.getNode(iIndex As Long) As Tlistnode Ptr
	
	Dim As Long iCount = count()
	
	If iIndex >= iCount Orelse iIndex < 0 Orelse pFirst = 0 Then
		
		Return Cast(Any Ptr, -1)
		
	Endif	
	
	Dim As Tlistnode Ptr pTemp = pFirst
	
	Dim As Long iListIndex
	
	While pTemp
		
		If iIndex = iListIndex Then
			
			Return pTemp
			
		Endif
		
		iListIndex+=1
		
		pTemp = pTemp->pNext
		
	Wend		
	
End Function

Sub Tlist.insert( iIndex As Integer , pszCommand As Zstring Ptr , pszName As Zstring Ptr )
	
	If pFirst = 0 Then
		
		pFirst = New Tlistnode
		
		if pFirst = 0 then
			
			#if __fb_out_exe__
				winout_error_memory_proc()
			#EndIf
			
			exit sub
			
		EndIf
		
		pFirst->pszCommand = pszCommand
		
		pFirst->pszName = pszName
		
	Else
		
		Dim As Long iCount = count()
		
		Dim As Tlistnode Ptr pTemp = pFirst , pTempNew
		
		Dim As Long iListIndex
		
		If iIndex = 0 Then
			
			pTempNew = New Tlistnode
			
			if pTempNew = 0 then
				
				#if __fb_out_exe__
					winout_error_memory_proc()
				#EndIf
				
				exit sub
				
			EndIf
			
			pFirst->pPrev = pTempNew
			
			pTempNew->pNext = pFirst
			
			pFirst = pTempNew
			
			pTempNew->pszCommand = pszCommand
			
			pTempNew->pszName = pszName			
			
		Else
			
			If iIndex >= iCount Then
				
				pTempNew = New Tlistnode
				
				if pTempNew = 0 then
					
					#if __fb_out_exe__
						winout_error_memory_proc()
					#EndIf
					
					exit sub
					
				EndIf
				
				While pTemp
					
					If pTemp->pNext = 0 Then
						
						pTemp->pNext = pTempNew
						
						pTempNew->pPrev = pTemp
						
						pTempNew->pszCommand = pszCommand
						
						pTempNew->pszName = pszName
						
						Exit While
						
					Endif
					
					pTemp = pTemp->pNext
					
				Wend
				
			Else
				
				While pTemp
					
					If iListIndex = iIndex Then
						
						pTempNew = New Tlistnode
						
						if pTempNew = 0 then
							
							#if __fb_out_exe__
								winout_error_memory_proc()
							#EndIf
							
							exit sub
							
						EndIf
						
						pTempNew->pNext = pTemp
						
						pTempNew->pPrev = pTemp->pPrev
						
						pTemp->pPrev->pNext = pTempNew
						
						pTemp->pPrev = pTempNew
						
						pTempNew->pszCommand = pszCommand
						
						pTempNew->pszName = pszName
						
						Exit While
						
					Endif
					
					pTemp = pTemp->pNext
					
					iListIndex+=1
					
				Wend
				
			Endif
			
		Endif
		
	Endif
	
End Sub

Sub Tlist.delAll()
	
	Dim As Tlistnode Ptr pTemp = pFirst , pTemp2
	
	While pTemp
		
		pTemp2 = pTemp
		
		pTemp = pTemp->pNext
		
		If (pTemp2->pszCommand) Then Deallocate(pTemp2->pszCommand)
		
		If (pTemp2->pszName) Then Deallocate(pTemp2->pszName)
		
		Delete pTemp2
		
	Wend
	
End Sub

Function Tlist.del( iIndex As Integer ) As Integer
	
	If pFirst = 0 Then
		
		Return -1
		
	Else
		
		Dim As Long iCount = count()
		
		If iIndex >= iCount Orelse iIndex < 0 Then
			
			Return -1
			
		Endif
		
		Dim As Tlistnode Ptr pTemp = pFirst , pTemp2
		
		Dim As Long iListIndex
		
		While pTemp
			
			If iListIndex = iIndex Then
				
				If pTemp = pFirst Then
					
					pFirst = pTemp->pNext
					
					If pFirst Then pFirst->pPrev = 0
					
				Else
					
					If pTemp->pNext = 0 Then
						
						pTemp->pPrev->pNext = 0
						
					Else
						
						pTemp->pPrev->pNext = pTemp->pNext
						
						pTemp->pNext->pPrev = pTemp->pPrev
						
					Endif
					
				Endif
				
				If (pTemp->pszCommand) Then Deallocate ( pTemp->pszCommand )
				
				If (pTemp->pszName) Then Deallocate ( pTemp->pszName )
				
				Delete pTemp
				
				Exit While
				
			Endif
			
			pTemp = pTemp->pNext
			
			iListIndex+=1
			
		Wend
		
	Endif
	
End Function

Function Tlist.Move( iIndexFrom As Long  , iIndexIn As Long) As Integer
	
	If iIndexFrom = iIndexIn Orelse pFirst = 0 Then
		
		Return -1
		
	Endif
	
	Dim As Long iCount = count()
	
	If iIndexFrom >= iCount Orelse iIndexFrom < 0 Orelse iIndexIn >= iCount Orelse iIndexIn < 0 Then
		
		Return -1
		
	Endif
	
	Dim As Tlistnode Ptr pOut  , pIn , pTemp = pFirst , pTemp2
	
	Dim As Long iListIndex
	
	While pTemp
		
		If iListIndex = iIndexFrom Then
			
			pOut = pTemp
			
		Elseif iListIndex = iIndexIn Then
			
			pIn = pTemp
			
		Endif
		
		pTemp = pTemp->pNext
		
		iListIndex+=1
		
		If pOut Andalso pIn Then Exit While
		
	Wend
	
	If pOut->pNext = 0  Andalso pIn->pPrev = 0 Then
		
		pOut->pPrev->pNext = 0
		
		pIn->pPrev = pOut
		
		pOut->pNext = pIn
		
		pOut->pPrev = 0
		
		pFirst = pOut
		
	Elseif pOut->pPrev = 0  Andalso pIn->pNext = 0 Then
		
		pOut->pNext->pPrev = 0
		
		pFirst = pOut->pNext
		
		pIn->pNext = pOut
		
		pOut->pNext = 0
		
		pOut->pPrev = pIn
		
	Elseif pOut->pNext = 0 Then
		
		pOut->pPrev->pNext = 0
		
		pIn->pPrev->pNext = pOut
		
		pOut->pPrev = pIn->pPrev
		
		pOut->pNext = pIn
		
		pIn->pPrev = pOut
		
	Elseif pOut->pPrev = 0 Then
		
		pOut->pNext->pPrev = 0
		
		pFirst = pOut->pNext
		
		pIn->pNext->pPrev = pOut
		
		pOut->pNext = pIn->pNext
		
		pOut->pPrev = pIn
		
		pIn->pNext = pOut
		
	Elseif pIn->pNext = 0 Then
		
		pOut->pPrev->pNext = pOut->pNext
		
		pOut->pNext->pPrev = pOut->pPrev
		
		pIn->pNext = pOut
		
		pOut->pPrev = pIn
		
		pOut->pNext = 0
		
	Elseif pIn->pPrev = 0 Then
		
		pOut->pPrev->pNext = pOut->pNext
		
		pOut->pNext->pPrev = pOut->pPrev
		
		pOut->pNext = pIn
		
		pIn->pPrev = pOut
		
		pFirst = pOut
		
		pOut->pPrev = 0
		
	Else
		
		pOut->pNext->pPrev = pOut->pPrev
		
		pOut->pPrev->pNext = pOut->pNext
		
		If iIndexFrom < iIndexIn Then
			
			pIn->pNext->pPrev = pOut
			
			pOut->pNext = pIn->pNext
			
			pIn->pNext = pOut
			
			pOut->pPrev = pIn
			
		Else
			
			pIn->pPrev->pNext = pOut
			
			pOut->pPrev = pIn->pPrev
			
			pOut->pNext = pIn
			
			pIn->pPrev = pOut
			
		Endif
		
	Endif
	
End Function


Type NodeTMultiCommentsLinePositions
	
	As Long iLineB = -1
	
	As Long iLineE = -1
	
	As NodeTMultiCommentsLinePositions Ptr pNext = 0	
	
End Type

Type TMultiCommentsLinePositions
	
	As NodeTMultiCommentsLinePositions Ptr pFirst = 0
	
	As NodeTMultiCommentsLinePositions Ptr pLast = 0
	
	As Long iCount
	
	Declare Sub delAll()	
	
	Declare Sub addLast(iB As Long , iE As Long)
	
	Declare Function IsIn(i As Long) As Long
	
End Type


Sub TMultiCommentsLinePositions.delAll()
	
	Dim As NodeTMultiCommentsLinePositions Ptr pTemp = pFirst , pTemp2
	
	While pTemp
		
		pTemp2 = pTemp
		
		pTemp = pTemp->pNext
		
		Delete pTemp2
		
	Wend	
	
End Sub

Sub TMultiCommentsLinePositions.addLast(iB As Long , iE As Long)
	
	If pFirst = 0 Then
		
		pFirst = New NodeTMultiCommentsLinePositions
		
		if pFirst = 0 then
			
			#if __fb_out_exe__
				winout_error_memory_proc()
			#EndIf
			
			exit sub
			
		EndIf
		
		pFirst->iLineB = iB
		
		pFirst->iLineE = iE
		
		pLast = pFirst
		
	Else
		
		Dim pNew As NodeTMultiCommentsLinePositions Ptr = New NodeTMultiCommentsLinePositions
		
		if pNew = 0 then
			
			#if __fb_out_exe__
				winout_error_memory_proc()
			#EndIf
			
			exit sub
			
		EndIf
		
		pNew->iLineB = iB
		
		pNew->iLineE = iE
		
		pLast->pNext = pNew
		
		pLast = pNew
		
	Endif
	
	iCount+=1
	
End Sub

Function TMultiCommentsLinePositions.IsIn(i As Long) As Long
	
	Dim As NodeTMultiCommentsLinePositions Ptr pTemp = pFirst
	
	While pTemp
		
		If pTemp->iLineB <> pTemp->iLineE Then
			
			If i >= pTemp->iLineB Andalso i <= pTemp->iLineE Then
				
				Return 1
				
			Endif			
			
		Endif
		
		pTemp = pTemp->pNext
		
	Wend
	
End Function

Type NODETHELPLIST
	
	As Zstring Ptr psz
	
	As NODETHELPLIST Ptr pNext = 0	
	
End Type

Type THELPLIST
	
	As NODETHELPLIST Ptr pFirst = 0
	
	As NODETHELPLIST Ptr pLast = 0
	
	Declare Sub delAll()
	
	Declare Sub addLast(As String)
	
End Type

Sub THELPLIST.delAll()
	
	Dim As NODETHELPLIST Ptr pTemp = pFirst , pTemp2
	
	While pTemp
		
		pTemp2 = pTemp
		
		pTemp = pTemp->pNext
		
		If pTemp2->psz Then Deallocate(pTemp2->psz)
		
		Delete pTemp2
		
	Wend	
	
End Sub

Sub THELPLIST.addLast(s As String)
	
	If Len(s) Then
		
		Dim pNew As NODETHELPLIST Ptr = New NODETHELPLIST
		
		If pNew Then
			
			pNew->psz = Callocate(Len(s)+1)
			
			If pNew->psz Then
				
				*(pNew->psz) = s
				
				If pFirst = 0 Then
					
					pFirst = pNew
					
					pLast = pFirst
					
				Else
					
					pLast->pNext = pNew
					
					pLast = pNew
					
				Endif
				
			Else
				
				Delete pNew
				
				#if __fb_out_exe__
					winout_error_memory_proc()
				#EndIf
				
			Endif
			
		else
			
			#if __fb_out_exe__
				winout_error_memory_proc()
			#EndIf
			
		Endif
		
	Endif
	
End Sub

Type TQueueList
	
	As Zstring Ptr psPath = 0
	
	As TQueueList Ptr p = 0
	
End Type

Type TQueue
	
	iIndex As Long = 0
	
	pF As TQueueList Ptr = 0
	
	Declare Sub AddQueue(v As String) ' in utf8
	
	Declare Function move(iPos As Long) As Long
	
	Declare Function GetName(psz As Zstring Ptr) As String ' in utf8
	
	Declare Function GetPath(psz As Zstring Ptr) As String ' in default system
	
End Type

Sub TQueue.AddQueue(v As String)
	
	Dim As Long iLen = Len(v)
	
	If iLen = 0 Then Exit Sub
	
	If iIndex Then
		
		Dim p As TQueueList Ptr = pF
		
		For i As Long = 1 To iIndex
			
			If p Andalso p->psPath Then
				
				If *(p->psPath) = v Then
					
					move(i)
					
					Exit Sub
					
				Endif
				
				p = p->p
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
	Endif
	
	Dim pTemp As TQueueList Ptr = New TQueueList
	
	if pTemp = 0 then
		
		#if __fb_out_exe__
			winout_error_memory_proc()
		#EndIf
		
		exit sub
		
	EndIf
	
	pTemp->psPath = Callocate(iLen + 1)
	
	if pTemp->psPath then
		
		*(pTemp->psPath) = v
		
		If iIndex < 10 Then
			
			If iIndex = 0 Then
				
				pF = pTemp
				
			Else
				
				pTemp->p = pF
				
				pF = pTemp
				
			Endif
			
			iIndex+=1
			
		Else
			
			pTemp->p = pF
			
			pF = pTemp		
			
			Dim As TQueueList Ptr pDel = pF
			
			For i As Long = 1 To 10
				
				If pDel->p Then
					
					pDel = pDel->p
					
				Else
					
					If pDel->psPath Then
						
						Deallocate(pDel->psPath)
						
						pDel->psPath = 0
						
					Endif
					
					Delete pDel
					
					pDel = 0
					
					Exit For
					
				Endif
				
			Next
			
		Endif
		
	else
		#if __fb_out_exe__
			winout_error_memory_proc()
		#EndIf
	endif
	
End Sub

Function TQueue.move(iPos As Long) As Long
	
	If iIndex < 2 Orelse iPos <= 1 Orelse iPos > iIndex Then Return 0
	
	Redim dimS(1 To iIndex) As String
	
	Dim As TQueueList Ptr p = pF , pDel
	
	For i As Long = 1 To iIndex
		
		If p Andalso p->psPath Then
			
			dimS(i) = *(p->psPath)
			
			Deallocate (p->psPath)
			
			pDel = p
			
			p = p->p
			
			Delete pDel
			
		Endif
		
	Next
	
	iIndex = 0
	
	For i As Long = Ubound(dimS) To 1 Step -1
		
		If i = iPos Then
			
			Continue For
			
		Endif
		
		AddQueue(dimS(i))
		
	Next
	
	AddQueue(dimS(iPos))
	
	Return 1
	
End Function

Function TQueue.GetName(psz As Zstring Ptr) As String
	
	#ifdef __fb_win32__
		Dim As String sSep = "\"
	#else	
		Dim As String sSep = "/"
	#endif
	
	if psz then
	
		Dim As Long iPos = Instrrev(*psz , sSep)
		
		If iPos Then
			
			Return Mid(*psz , iPos+1)
			
		Endif
	
	endif
	
End Function

#if __fb_out_exe__
	Function TQueue.GetPath(psz As Zstring Ptr) As String
		
		If psz andalso Len(*psz) Then
			
			Return enc_encode_path_proc(*psz , 0)
			
		Endif
		
	End Function
#endif