' Set Style (color,font) for "window output information"
Sub winout_set_visual_params_build_info_proc(iParam As Byte = 0) Export

	optdlg_get_theme_color_proc(iParam)

	IupSetAttribute(TGlobalVariables->buildbox, "BGCOLOR" , TGlobalVariables->szColorbtn(2))

	IupSetAttribute(TGlobalVariables->buildbox, "FGCOLOR" , TGlobalVariables->szColorbtn(10))

	Dim As Zstring*100 szFont

	If iParam = 0 Then

		szFont = *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Fonts","winout")

	Else

		szFont = *IupGetAttribute(IupGetDialogChild(TGlobalVariables->hOptions,"ftxtwinout"),"VALUE")

	Endif

	If Instr(szFont, " Bold ") Then

		szFont = misc_replace_string_proc(szFont , " Bold " , " " )

	Endif

	If Instr(szFont, " Italic ") Then

		szFont = misc_replace_string_proc(szFont , " Italic " , " " )

	Endif

	If Instr(szFont, " Underline ") Then

		szFont = misc_replace_string_proc(szFont , " Underline " , " " )

	Endif

	If Instr(szFont, " Strikeout ") Then

		szFont = misc_replace_string_proc(szFont , " Strikeout " , " " )

	Endif

	Dim As Integer iPosSpace = Instrrev(szFont , " ")

	TGlobalVariables->szFontWinOutSize = Mid(szFont , iPosSpace , (Len(szFont) - iPosSpace)+1)

	TGlobalVariables->szFontWinOut = Rtrim(Mid(szFont , 1 , iPosSpace) , Any " ,")

	IupSetAttribute(TGlobalVariables->buildbox, "FONTFACE" , TGlobalVariables->szFontWinOut)

	IupSetAttribute(TGlobalVariables->buildbox, "FONTSIZE" , TGlobalVariables->szFontWinOutSize)

End Sub

' Create window output information: compilation, search
Function winout_Create_build_info_BuildBox_proc() As IHandle Ptr Export

	Dim As IHandle Ptr pList = IupList(NULL)

	IupSetAttributes(pList, "EXPAND=YES")

	IupSetAttributes(pList, "MULTIPLE=YES")

	IupSetAttributes(pList, "MAXSIZE=x400")

	IupSetCallback(pList, "BUTTON_CB", Cast(Any Ptr,@buildbox_button_callback))

	Return pList

End Function

'SARG
sub winout_find_asmerrorlines_proc(sPathFileError as string,errorline as integer)

	Dim As Long iTabsCompFile = Val(*IupGetAttribute(TGlobalVariables->tabs, "CURRENTCOMPILE"))

	Dim As String sPathCurrent = *IupGetAttribute(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext,"FILEPATH") & _
		*IupGetAttribute(TGlobalVariables->tTabsOptions(IupGetInt(TGlobalVariables->tabs, "VALUEPOS")).multitext,"FILENAME")	

	dim as integer idtabs = IupGetInt(TGlobalVariables->tabs, "VALUEPOS")

	sPathFileError = enc_encode_path_proc(sPathFileError , 0)
					
	If sPathFileError <> sPathCurrent Then
		''need to find or load
		Dim As Integer iCountTabs = IupGetInt(TGlobalVariables->tabs, "COUNT")
		
		Dim As integer iFlagFound
		
		For i As integer  = 1 To iCountTabs - 1
			
			sPathCurrent = *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILEPATH") & _
			*IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILENAME")

			If sPathFileError = sPathCurrent Then

				idTabs = i
				
				IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(i))
				
				IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)

				dim as zstring ptr pszEnc = IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CURRENTENCODING")

				if FileExists(sPathFileError) = 0 then exit sub
				
				fl_re_open_file_proc(pszEnc)

				iFlagFound = 1
				
				Exit For
				
			Endif
			
		Next
		
		if iFlagFound = 0 then

			'' not loaded so try to load but could be not existing if compile option (-R or -RR) not set
			if FileExists(sPathFileError) = 0 then exit sub

			fl_open_file_proc(sPathFileError)
			
			idTabs = iCountTabs
			

		End If

	End If

	Dim As Integer iNumberLinesEditor = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")

	If iNumberLinesEditor < errorline Then exit sub

	dim as integer iPos

	IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, errorline - 1, 0, Cast(Any Ptr,@iPos))

	IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_SETXOFFSET , 0, 0)

	If errorline Then

		IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GOTOLINE , errorline -1 , 0)

	Endif

	dim as integer iLenLine = Len(Rtrim(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & (errorline -1)), Any Chr(13) & Chr(10) ))

	IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPos, iPos+ilenline)

	mtxt_line_display_proc(TGlobalVariables->tTabsOptions(idTabs).multitext,_
	Cast(Integer , IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext,_
	SCI_LINEFROMPOSITION , iPos , Cast(Integer , 0))))

	IupSetFocus(TGlobalVariables->buildbox)

end sub

Function winout_find_errorlines_proc(sTextError As String  , sFindErr As String ) As Integer Export
	If Len(sTextError) = 0 Then Return 0

	Dim As Byte bFlagOpenFile

	Dim As Long idTabs


	Dim As Long iTabsCompFile = Val(*IupGetAttribute(TGlobalVariables->tabs, "CURRENTCOMPILE"))
	
	If iTabsCompFile = 0 Then Return 0
	
	'========= SARG
	dim as integer ipos = instr(sTextError,".asm:")

	if ipos <> 0 then

		dim as integer nline = valint(mid(sTextError,ipos+5,7))

		if nline <> 0 then

			winout_find_asmerrorlines_proc(left(sTextError,ipos+3),nline)

		end if

		return 1

	end if

	'============


	Dim As Long iFindPos = 1

	iFindPos = Instr(iFindPos , sTextError , sFindErr)

	If iFindPos Then

		Dim As Long iFindColon = Instr(iFindPos , sTextError , ":")

		If iFindColon Then

			If (iFindColon - iFindPos) < 20 Then

				Dim As Long iFindBegin = Instrrev( sTextError , "(" , iFindPos)

				Dim As String sPathFileError = Left(sTextError , iFindBegin-1)

				Dim As String sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext,"FILEPATH") & _
				*IupGetAttribute(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext,"FILENAME")

				sPathFileError = enc_encode_path_proc(sPathFileError , 0)

				If sPathFileError <> sPathCurent  Andalso Instr(sPathFileError,"FBTEMP.bas") = 0 Then

					Dim As Integer iCountTabs = IupGetInt(TGlobalVariables->tabs, "COUNT")

					Dim As Byte iFlagFound

					For i As Long  = 1 To iCountTabs - 1

						sPathCurent = *IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILEPATH") & _
						*IupGetAttribute(TGlobalVariables->tTabsOptions(i).multitext,"FILENAME")

						If sPathFileError = sPathCurent Then

							idTabs = i

							IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(i))

							IupSetFocus(TGlobalVariables->tTabsOptions(idTabs).multitext)

							iFlagFound = 1

							Exit For

						Endif

					Next

					If iFlagFound = 0 Then

						Dim As iHandle Ptr mtReturn

						Dim As Long iRet = fl_is_fileproject_to_open_proc(sPathFileError , mtReturn)

						If iRet = 0 Then

							fl_open_file_proc(sPathFileError)

						Else

							fl_save_project_proc(0)

							If *IupGetAttribute(IupGetDialogChild(TGlobalVariables->dlg,"btnprjsidewin") , "VALUE") = "ON" Then

								winside_addInfo_prj_inlist_proc()

							Endif

						Endif

						idTabs = iCountTabs

						bFlagOpenFile = 1

					Endif

				Else

					IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(iTabsCompFile))

					IupSetFocus(TGlobalVariables->tTabsOptions(iTabsCompFile).multitext)

					idTabs = iTabsCompFile

				Endif

				Dim As Integer iIndexList = Val( Mid(sTextError , iFindBegin+1 , (iFindPos - iFindBegin)-1) )

				Dim As Integer iNumberLinesEditor = IupGetInt(TGlobalVariables->tTabsOptions(idTabs).multitext, "LINECOUNT")

				If iNumberLinesEditor < iIndexList Then Return 0

				Dim As Integer iPos , iPos2 , iLenLine

				iLenLine = Len(Rtrim(*IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext , "LINE" & (iIndexList -1)), Any Chr(13) & Chr(10) ))

				IupTextConvertLinColToPos(TGlobalVariables->tTabsOptions(idTabs).multitext, iIndexList - 1, 0, Cast(Any Ptr,@iPos))

				iPos2 = iPos + iLenLine

				If bFlagOpenFile Orelse *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "PRGNOACTIVE") = "1" Then

					IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "SCROLLAFTERERROR", Str(iIndexList))

					Dim As iHandle Ptr hTimer = IUPtimer()

					IupSetAttribute(hTimer, "TIME", "100")

					IupSetCallback(hTimer, "ACTION_CB", Cast(Any Ptr,@timer_scroll_after_openerrorfile_callback()))

					IupSetAttribute(hTimer, "RUN", "YES")

					IupSetStrAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "PRGNOACTIVE", "0")

				Else

					IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_SETXOFFSET , 0, 0)

					If iIndexList Then

						IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GOTOLINE , iIndexList -1 , 0)

					Endif

					IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPos, iPos2)

					mtxt_line_display_proc(TGlobalVariables->tTabsOptions(idTabs).multitext,_
					Cast(Integer , IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext,_
					SCI_LINEFROMPOSITION , iPos , Cast(Integer , 0))))

					IupSetFocus(TGlobalVariables->buildbox)

				Endif

				Return 1

			Endif

		Endif

	Endif

End Function

Sub winout_processing_click_mouse_buildbox_proc(ih As Ihandle Ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As Zstring Ptr) Export

	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub

	Select Case button

		Case IUP_BUTTON1

			If pressed = 0 Then

				Dim As Integer iCount = Val(*IupGetAttribute(ih,"COUNT"))  , iCountSelectedItems

				Dim As String sStatusSelect = *IupGetAttribute(ih,"VALUE")

				For i As Long = 1 To iCount

					If Mid(sStatusSelect , i , 1) = "+" Then

						iCountSelectedItems+=1

						If iCountSelectedItems > 1 Then

							Exit Sub

						Endif

					Endif

				Next

				If TGlobalVariables->bFlagFindInfo = 1 Then

					Dim As Zstring Ptr pszFind = IupGetAttribute(TGlobalVariables->tabs , "FOUNDSTRING")

					If *pszFind <> "" Then

						Dim As Integer iPos = IupConvertXYToPos(ih , x ,y)

						If iPos = Cint(-1) Then Exit Sub

						Dim As Zstring Ptr pszText = IupGetAttribute(ih, Str(iPos))

						If pszText Andalso Len(*pszText) Then

							Dim As Integer iPosbeg , iPosend , iFind1 , iFind2 , idTabs

							If Instr(*pszText , "{Tab=") Andalso Instr(*pszText , "; Pos=") _
							Andalso Instr(*pszText , "; Line=") Andalso Instr(*pszText , "; Column=") Then

								dim ipostab as integer = instr(*pszText,"{Tab=") ''lolo

								iFind1 = Instr(ipostab+5,*pszText,";")

								idTabs = Val(Mid(*pszText,ipostab+5,iFind1-ipostab-5))

								iFind1 = Instr(iFind1+1 , *pszText,"=")

								iFind2 = Instr(iFind1+1 , *pszText,";")

								iPosbeg = Val(Mid(*pszText,iFind1+1,iFind2-(iFind1+1)))

								iPosend = iPosbeg + Len(*pszFind)

								If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Exit Sub

								IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(idTabs))

								IupFlush()

								IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_SETXOFFSET , 0, 0)

								IupSetStrf(TGlobalVariables->tTabsOptions(idTabs).multitext, "SELECTIONPOS", !"%d:%d", iPosbeg, iPosend)

								mtxt_line_display_proc(TGlobalVariables->tTabsOptions(idTabs).multitext,_
								Cast(Integer , IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext,_
								SCI_LINEFROMPOSITION , iPosbeg , Cast(Integer , 0))))

								IupSetFocus(TGlobalVariables->buildbox)

							Endif

						Endif

					Endif

				Elseif TGlobalVariables->bFlagFindInfo = 2 Then

					If iCount > 1 Then

						Dim As Integer iPos = IupConvertXYToPos(ih , x ,y)

						Dim As Zstring Ptr pszText = IupGetAttribute(ih, Str(iPos))

						If pszText Andalso Len(*pszText) Then

							If Left(*pszText , 4) = "TAB " Then

								Dim As Long iFpos = Instr(*pszText , ";")

								If iFpos Then

									Dim As Long idTabs = Val(Mid(*pszText , 5 , iFpos - 5))

									If idTabs Then

										IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS",Str(idTabs))

										IupFlush()

									Endif

								Endif

							Endif

						Endif

					Endif

				Else

					Dim As Integer iPos

					iCount = Val(*IupGetAttribute(ih,"COUNT"))

					iPos = IupConvertXYToPos(ih , x ,y)

					Select Case iPos

						Case Cint(-1) , Cint(1) , Cint(2) , Cint(iCount)

							Exit Sub

					End Select

					Dim As String sTextError = *IupGetAttribute(ih, Str(iPos))

					If winout_find_errorlines_proc(sTextError , ") error ") = 0 Then

						winout_find_errorlines_proc(sTextError , ") warning ")

					Endif

				Endif

				tmr_update_after_changes()

			Endif

		Case IUP_BUTTON3

			If pressed = 0 Then

				Dim As Integer iCount

				iCount = Val(*IupGetAttribute(ih,"COUNT"))

				If iCount Then

					mn_menu_popup_buildbox_proc()

				Endif

			Endif

	End Select

End Sub

' 0 - select items text , 1 - all items text
Sub winout_copy_text_from_buildbox_proc( bParam As Byte) Export

	Dim As String sText

	Dim As String sEOL

	#ifdef __fb_win32__

		sEOL = Chr(13) & Chr(10)

	#else

		sEOL = Chr(10)

	#endif

	Dim As Ihandle Ptr bb = TGlobalVariables->buildbox

	Dim As Integer iCount = Val(*IupGetAttribute(bb,"COUNT"))

	If bParam  = 0 Then

		Dim As String sStatusSelect = *IupGetAttribute(bb,"VALUE")

		For i As Long = 1 To iCount

			If Mid(sStatusSelect , i , 1) = "+" Then

				sText &= (*IupGetAttribute(bb,Str(i)) & sEOL)

			Endif

		Next

	Else

		For i As Long = 1 To iCount

			sText &= (*IupGetAttribute(bb,Str(i)) & sEOL)

		Next

	Endif

	If Len(sText) Then

		Dim As Ihandle Ptr clipboard = IupClipboard()

		IupSetAttribute(clipboard, "TEXT", sText)

		IupDestroy(clipboard)

	Endif

End Sub

' processing popup menu buildbox show only errors
Sub winout_popup_buildbox_only_errors_proc () Export

	Dim As Long iIndex = 3

	Static As Zstring*12 szResult

	szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))

	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")

	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))

	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")

	For i As Long = 3 To 1000

		If pszDimErrors(i) Then

			If Instr(*(pszDimErrors(i)),") warning ") Then

			Else

				IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))

				iIndex +=1

			Endif

		Endif

	Next

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult)

End Sub

' processing popup menu buildbox show only warnings
Sub winout_popup_buildbox_only_warnings_proc () Export

	Dim As Long iIndex = 3

	Static As Zstring*12 szResult

	szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))

	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")

	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))

	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")

	For i As Long = 3 To 1000

		If pszDimErrors(i) Then

			If Instr(*(pszDimErrors(i)),") warning ") Then

				IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))

				iIndex +=1

			Endif

		Endif

	Next

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult)

End Sub

' processing popup menu buildbox show warnings and errors
Sub winout_popup_buildbox_errors_and_warnings_proc () Export

	Dim As Long iIndex = 3

	Static As Zstring*12 szResult

	szResult = *IupGetAttribute(TGlobalVariables->buildbox,IupGetAttribute(TGlobalVariables->buildbox , "COUNT"))

	IupSetfAttribute(TGlobalVariables->buildbox , "REMOVEITEM", "ALL")

	IupSetfAttribute(TGlobalVariables->buildbox , "1", pszDimErrors(1))

	IupSetfAttribute(TGlobalVariables->buildbox , "2", " ")

	For i As Long = 3 To 1000

		If pszDimErrors(i) Then

			IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex) , pszDimErrors(i))

			iIndex +=1

		Endif

	Next

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex), " ")

	IupSetfAttribute(TGlobalVariables->buildbox , Str(iIndex+1), szResult)

End Sub

sub winout_error_memory_proc()

	static sError as zstring*50

	sError = "Error allocated memory! Time: " & time

	IupSetfAttribute(TGlobalVariables->buildbox , "1", sError)

End Sub
